// Copyright(c) 2oo1 by Mental Vortex
#ifndef _ANM_H_
#define _ANM_H_
// 
// Description:
// 
// Lionhead Animation File Format .anm
// 
// 
// 
// 




// Includes
#include "math.h"						// This include file includes the math functions




//
// Here starts the Important stuff for current Animations
//

//
// This is the Base Header structure
//
struct ANM_BaseHeader
{
	char		mAnimName[32];			// Name of the Animation

	DWORD		mUnk_1;
	DWORD		mUnk_2;

	DWORD		mUnk_3;
	DWORD		mUnk_4;

	DWORD		mUnk_5;
	DWORD		mUnk_6;

	//
	// number of Frames
	DWORD		mnFrames;

	DWORD		mUnk_8;
	DWORD		mpNextAni;		// is it nextani, or just size of this file ? -> its definitively more, check out allanims.anm
	DWORD		mUnk_10;

	DWORD		mpParents;		// number of parents is number of bones of original model
								// check with number of bones in ANM_Frame
								// a parent is a DWORD, mDepencies[bone] gives index for bone's parent
	//
	// Points to a list of n pointers, of which each  
	// points to pointers that points to a pointer that points to a ANM_Frame :)
	// Lionhead, why did u do that ? was quite confusing .... :)
	// 
	DWORD		mpFrames;

	
	DWORD		mUnk_13;
};



//
// a Bone
//
struct ANM_Bone
{
	Vec3				mXAxis;								// i think this is the rotation matrix
	Vec3				mYAxis;
	Vec3				mZAxis;

	Vec3				mPosition;							// this should be the Position offset	
};



//
// this is what the frame structure looks like
//
struct ANM_Frame
{
	int			mnBones;
	ANM_Bone*	mpBones;
};



//
// ANM List File Body Block Header
//
struct LHANM_Body
{
  	DWORD				mnID;				// always MKJC... JC = Jean-Claude Cottier 
	DWORD				mnAnims;			// Number of Animations = MAX_COUNT_3D_ANIMS from "AllMeshes.h"
};




#endif//_ANM_H_