// Copyright(c) 2oo1 by Darkyoda and MENTAL VORTEX

// 
// Description:
// 
// Black and White G3D File Loader
// 
//
// 
// 


//
// Comments :
//
// 16.April
// DY : Created this File
//
//
//



// Includes
#include			"main.h"
#include			"dxt.h"


//
// Globals
//
char		gpG3DFilename[256];

char				*gpG3DData			= NULL;
DWORD				gG3DSize			= 0;

G3D_Meshes			*gpMeshes			= NULL;
G3D_HiResTexture	**gpHiResTextures	= NULL;
byte				**gpDeCompressedTextures	= NULL;

unsigned int		*gpG3DBinds			= NULL;
int					gnG3DBinds			= 0;


//
// a "small" stringlist :)
//

char	gG3DStringList[MAX_COUNT_3D_MESHES+1][40] = 
{
    "MSH_DUMMY",
    "MSH_A_BAT_1",
    "MSH_A_BAT_2",
    "MSH_A_CROW_1",
    "MSH_A_CROW_2",
    "MSH_A_DOVE_1",
    "MSH_A_DOVE_2",
    "MSH_A_PIGEON_1",
    "MSH_A_PIGEON_2",
    "MSH_A_SEAGULL_1",
    "MSH_A_SEAGULL_2",
    "MSH_A_SPELL_DOVE",
    "MSH_A_SWALLOW_1",
    "MSH_A_SWALLOW_2",
    "MSH_A_VULTURE_1",
    "MSH_A_VULTURE_2",
    "MSH_A_COW_1",
    "MSH_A_COW_2",
    "MSH_A_COW_3",
    "MSH_A_HORSE_1",
    "MSH_A_HORSE_2",
    "MSH_A_HORSE_3",
    "MSH_A_LEOPARD_1",
    "MSH_A_LEOPARD_2",
    "MSH_A_LEOPARD_3",
    "MSH_A_LION_1",
    "MSH_A_LION_2",
    "MSH_A_LION_3",
    "MSH_A_PIG_1",
    "MSH_A_PIG_2",
    "MSH_A_PIG_3",
    "MSH_SHARK_BONED",
    "MSH_A_SHEEP_1",
    "MSH_A_SHEEP_2",
    "MSH_A_SHEEP_3",
    "MSH_A_TIGER_1",
    "MSH_A_TIGER_2",
    "MSH_A_TIGER_3",
    "MSH_A_TORTOISE_1",
    "MSH_A_TORTOISE_2",
    "MSH_A_TORTOISE_3",
    "MSH_A_WOLF_1",
    "MSH_A_WOLF_2",
    "MSH_A_WOLF_3",
    "MSH_A_ZEBRA_1",
    "MSH_A_ZEBRA_2",
    "MSH_A_ZEBRA_3",
    "MSH_B_AMCN_1",
    "MSH_B_AMCN_1_A",
    "MSH_B_AMCN_2",
    "MSH_B_AMCN_2_A",
    "MSH_B_AMCN_3",
    "MSH_B_AMCN_3_A",
    "MSH_B_AMCN_4",
    "MSH_B_AMCN_5",
    "MSH_B_AMCN_CRECHE",
    "MSH_B_AMCN_FENCE",
    "MSH_B_AMCN_GRAVEYARD",
    "MSH_B_AMCN_TOTEM",
    "MSH_B_AMCN_WONDER",
    "MSH_B_AMCN_WORKSHOP",
    "MSH_B_AZTC_1",
    "MSH_B_AZTC_2",
    "MSH_B_AZTC_3",
    "MSH_B_AZTC_4",
    "MSH_B_AZTC_5",
    "MSH_B_AZTC_CRECHE",
    "MSH_B_AZTC_GRAVEYARD",
    "MSH_B_AZTC_OLMECHEAD",
    "MSH_B_AZTC_STATUE",
    "MSH_B_AZTC_TEMPLE",
    "MSH_B_AZTC_TOTEM",
    "MSH_B_AZTC_WONDER",
    "MSH_B_AZTC_WORKSHOP",
    "MSH_B_CELT_1",
    "MSH_B_CELT_2",
    "MSH_B_CELT_3",
    "MSH_B_CELT_4",
    "MSH_B_CELT_5",
    "MSH_B_CELT_5A",
    "MSH_B_CELT_CRECHE",
    "MSH_B_CELT_FENCE_SHORT",
    "MSH_B_CELT_FENCE_TALL",
    "MSH_B_CELT_GRAVEYARD",
    "MSH_B_CELT_GRAVE_01",
    "MSH_B_CELT_GRAVE_02",
    "MSH_B_CELT_GRAVE_03",
    "MSH_B_CELT_TOTEM",
    "MSH_B_CELT_WALLGATE_SPELL",
    "MSH_B_CELT_WALLTOWER_SPELL",
	"MSH_B_CELT_WALL_SPELL",
    "MSH_B_CELT_WONDER",
    "MSH_B_CELT_WORKSHOP",
    "MSH_B_CITADEL_AMCN_ALTAR",
    "MSH_B_CITADEL_AZTC_ALTAR",
    "MSH_B_CITADEL_CELT_ALTAR",
    "MSH_B_CITADEL_DESIRE_HUNGRY",
    "MSH_B_CITADEL_DESIRE_SLEEP",
    "MSH_B_CITADEL_EGPT_ALTAR",
    "MSH_B_CITADEL_GREK_ALTAR",
    "MSH_B_CITADEL_JAPN_ALTAR",
    "MSH_B_CITADEL_NORS_ALTAR",
    "MSH_B_CITADEL_POP_COUNTER_BEAD",
    "MSH_B_CITADEL_TIBT_ALTAR",
    "MSH_B_EGPT_1",
    "MSH_B_EGPT_1_A",
    "MSH_B_EGPT_2",
    "MSH_B_EGPT_2_A",
    "MSH_B_EGPT_3",
    "MSH_B_EGPT_4",
    "MSH_B_EGPT_5",
    "MSH_B_EGPT_5_A",
    "MSH_B_EGPT_BARREL",
    "MSH_B_EGPT_CART",
    "MSH_B_EGPT_CRECHE",
    "MSH_B_EGPT_GRAVEYARD",
    "MSH_B_EGPT_NEEDLE",
    "MSH_B_EGPT_POT_A",
    "MSH_B_EGPT_POT_B",
    "MSH_B_EGPT_TOTEM",
    "MSH_B_EGPT_WELL",
    "MSH_B_EGPT_WINDMILL",
    "MSH_B_EGPT_WONDER",
    "MSH_B_EGPT_WORKSHOP",
    "MSH_B_GREK_1",
    "MSH_B_GREK_2",
    "MSH_B_GREK_2_A",
    "MSH_B_GREK_3",
    "MSH_B_GREK_4",
    "MSH_B_GREK_5",
    "MSH_B_GREK_5A",
    "MSH_B_GREK_CRECHE",
    "MSH_B_GREK_GRAVEYARD",
    "MSH_B_GREK_SAIL",
    "MSH_B_GREK_STATUE",
    "MSH_B_GREK_TOTEM",
    "MSH_B_GREK_WONDER",
    "MSH_B_GREK_WORKSHOP",

    "MSH_B_JAPN_1",
    "MSH_B_JAPN_2",
    "MSH_B_JAPN_3",
    "MSH_B_JAPN_4",
    "MSH_B_JAPN_5",
    "MSH_B_JAPN_CRECHE",
    "MSH_B_JAPN_GRAVEYARD",
    "MSH_B_JAPN_TOTEM",
    "MSH_B_JAPN_WONDER",
    "MSH_B_JAPN_WORKSHOP",

    "MSH_B_CAMPFIRE",
    "MSH_B_CREATURE_PEN_LEASH_POLE",

    "MSH_B_FOOTBALL_CENTRECIRCLE",
    "MSH_B_FOOTBALL_CORNERFLAG",
    "MSH_B_FOOTBALL_GOAL",
    "MSH_B_FOOTBALL_PITCH",
    "MSH_B_FOOTBALL_PITCH_BIG",

    "MSH_B_MINE_ENTRANCE",
    "MSH_B_PIER",
    "MSH_B_SCAFFOLD_01",
    "MSH_B_SCAFFOLD_02",
    "MSH_B_SCAFFOLD_03",
    "MSH_B_XANDO_BASE",
    "MSH_B_XANDO_O",
    "MSH_B_XANDO_X",
    "MSH_PIPER_ENTRANCE_PHYS_1",

    "MSH_B_AMCN_VILLAGECENTRE",
    "MSH_B_AZTC_VILLAGECENTRE",
    "MSH_B_CELT_VILLAGECENTRE",

    "MSH_B_DESIRE_FLAG_ABODE",
    "MSH_B_DESIRE_FLAG_CHILDREN",
    "MSH_B_DESIRE_FLAG_CIVIC_BUILDING",
    "MSH_B_DESIRE_FLAG_FOOD",
    "MSH_B_DESIRE_FLAG_PLAYTIME",
    "MSH_B_DESIRE_FLAG_PROTECTION",
    "MSH_B_DESIRE_FLAG_RAIN",
    "MSH_B_DESIRE_FLAG_SUN",
    "MSH_B_DESIRE_FLAG_WOOD",

    "MSH_B_EGPT_VILLAGECENTRE",
    "MSH_B_GREK_VILLAGECENTRE",
    "MSH_B_JAPN_VILLAGECENTRE",
    "MSH_B_NORS_VILLAGECENTRE",

    "MSH_B_PLAYER_ICON01",
    "MSH_B_PLAYER_ICON01_PLINTH",
    "MSH_B_PLAYER_ICON_APE",
    "MSH_B_PLAYER_ICON_BEAR",
    "MSH_B_PLAYER_ICON_COW",
    "MSH_B_PLAYER_ICON_HORSE",
    "MSH_B_PLAYER_ICON_LEOPARD",
    "MSH_B_PLAYER_ICON_LION",
    "MSH_B_PLAYER_ICON_PLINTH_AMCN",
    "MSH_B_PLAYER_ICON_PLINTH_AZTC",
    "MSH_B_PLAYER_ICON_PLINTH_CELT",
    "MSH_B_PLAYER_ICON_PLINTH_EGPT",
    "MSH_B_PLAYER_ICON_PLINTH_GREK",
    "MSH_B_PLAYER_ICON_PLINTH_JAPN",
    "MSH_B_PLAYER_ICON_PLINTH_NORS",
    "MSH_B_PLAYER_ICON_PLINTH_TIBT",
    "MSH_B_PLAYER_ICON_POLARBEAR",
    "MSH_B_PLAYER_ICON_SHEEP",
    "MSH_B_PLAYER_ICON_TIGER",
    "MSH_B_PLAYER_ICON_TORTOISE",
    "MSH_B_PLAYER_ICON_WOLF",
    "MSH_B_PLAYER_ICON_ZEBRA",

    "MSH_B_TIBT_VILLAGECENTRE",
    "MSH_B_VILLAGECENTRE_SPELLHAND",
    "MSH_B_NORS_1",
    "MSH_B_NORS_2",
    "MSH_B_NORS_2_A",
    "MSH_B_NORS_3",
    "MSH_B_NORS_3_A",
    "MSH_B_NORS_4",
    "MSH_B_NORS_5",
    "MSH_B_NORS_CRECHE",
    "MSH_B_NORS_GATE",
    "MSH_B_NORS_GRAVEYARD",
    "MSH_B_NORS_PIGPEN",
    "MSH_B_NORS_TEMPLE",
    "MSH_B_NORS_TOTEM",
    "MSH_B_NORS_WONDER",
    "MSH_B_NORS_WORKSHOP",
    "MSH_NORS_GATE_PHYS_1",
    "MSH_NORS_GATE_PHYS_2",
    "MSH_B_AMCN_STORAGE_PIT",
    "MSH_B_AZTC_STORAGE_PIT",
    "MSH_B_CELT_STORAGE_PIT",
    "MSH_B_EGPT_STORAGE_PIT",
    "MSH_B_GRAIN",
    "MSH_B_GREK_STORAGE_PIT",
    "MSH_B_JAPN_STORAGE_PIT",
    "MSH_B_NORS_STORAGE_PIT",
    "MSH_B_TIBT_STORAGE_PIT",
    "MSH_B_WOOD_00",
    "MSH_B_WOOD_01",
    "MSH_B_WOOD_02",
    "MSH_B_WOOD_03",
    "MSH_B_WOOD_04",
    "MSH_B_WOOD_OUTSIDE",
    "MSH_B_TIBT_1",
    "MSH_B_TIBT_2",
    "MSH_B_TIBT_3",
    "MSH_B_TIBT_3_A",
    "MSH_B_TIBT_4",
    "MSH_B_TIBT_5",
    "MSH_B_TIBT_5_A",
    "MSH_B_TIBT_CRECHE",
    "MSH_B_TIBT_GRAVEYARD",
    "MSH_B_TIBT_LARGE_PILLER",
    "MSH_B_TIBT_MINI_TEMPLE",
    "MSH_B_TIBT_TOTEM",
    "MSH_B_TIBT_WONDER",
    "MSH_B_TIBT_WORKSHOP",
    "MSH_B_SPELLHAND",
    "MSH_B_WORSHIPGRAIN",
    "MSH_B_WORSHIPSITE_01_NEUTRAL",
    "MSH_BOULDER1_CHALK",
    "MSH_BOULDER1_LIME",
    "MSH_BOULDER1_SAND",
    "MSH_BOULDER1_VOLCANIC",
    "MSH_BOULDER2_CHALK",
    "MSH_BOULDER2_LIME",
    "MSH_BOULDER2_SAND",
    "MSH_BOULDER2_VOLCANIC",
    "MSH_BOULDER3_CHALK",
    "MSH_BOULDER3_LIME",
    "MSH_BOULDER3_SAND",
    "MSH_BOULDER3_VOLCANIC",
    "MSH_FAT_PILAR_CHALK",
    "MSH_FAT_PILAR_LIME",
    "MSH_FAT_PILAR_SAND",
    "MSH_FAT_PILAR_VOLCANIC",
    "MSH_F_CREATURE_CAVE",
    "MSH_F_FOREST",
    "MSH_F_FOREST01",
    "MSH_F_FOREST02",
    "MSH_F_FOREST03",
    "MSH_F_FOREST_BOOK01",
    "MSH_F_GIANTSKELETON",
    "MSH_F_GIANTSKULL",
    "MSH_F_IDOL",
    "MSH_F_PIPER_CAVE",
    "MSH_F_RIB1",
    "MSH_F_RIB2",
    "MSH_F_SPOUTHOLE",
    "MSH_F_VERTABRAE",
    "MSH_PILAR2_CHALK",
    "MSH_PILAR2_LIME",
    "MSH_PILAR2_SAND",
    "MSH_PILAR2_VOLCANIC",
    "MSH_PILAR3_CHALK",
    "MSH_PILAR3_LIME",
    "MSH_PILAR3_SAND",
    "MSH_PILAR3_VOLCANIC",
    "MSH_PILAR_CHALK",
    "MSH_PILAR_LIME",
    "MSH_PILAR_SAND",
    "MSH_PILAR_VOLCANIC",
    "MSH_PUZZLE_1",
    "MSH_PUZZLE_2",
    "MSH_PUZZLE_3",
    "MSH_PUZZLE_4",
    "MSH_PUZZLE_5",
    "MSH_SPIKEY_PILAR_CHALK",
    "MSH_SPIKEY_PILAR_LIME",
    "MSH_SPIKEY_PILAR_SAND",
    "MSH_SPIKEY_PILAR_VOLCANIC",
    "MSH_Z_PHONEBOX",
    "MSH_I_BLAST",
    "MSH_I_FIREBALL",
    "MSH_I_FOOD",
    "MSH_I_FOOTBALL",
    "MSH_I_FOREST",
    "MSH_I_HEAL",
    "MSH_I_LIGHTNING",
    "MSH_I_LIGHTNING2",
    "MSH_I_MINISCROLL",
    "MSH_I_MINISCROLL_ACTIVE",
    "MSH_I_MINISCROLL_BRONZE",
    "MSH_I_MINISCROLL_BRONZE_ACTIVE",
    "MSH_I_MINISCROLL_GOLD",
    "MSH_I_MINISCROLL_GOLD_ACTIVE",
    "MSH_I_MINISCROLL_SILVER",
    "MSH_I_MINISCROLL_SILVER_ACTIVE",
    "MSH_I_OFFERING_BEDROLL",
    "MSH_I_OFFERING_FERTILITY",
    "MSH_I_OFFERING_FOOD",
    "MSH_I_OFFERING_PLAY",
    "MSH_I_OFFERING_PROTECTION",
    "MSH_I_OFFERING_SKULL",
    "MSH_I_OFFERING_VILLAGE_IMPROVE",
    "MSH_I_OFFERING_WATER",
    "MSH_I_OFFERING_WOOD",
    "MSH_I_PRIEST",
    "MSH_I_SHIELD",
    "MSH_I_SKELETON",
    "MSH_I_SPELLGEM",
    "MSH_I_TREES",
    "MSH_I_WALL",
    "MSH_GATE_TOTEM_PLINTHE_PHYS_1",
    "MSH_GATE_TOTEM_PLINTHE_PHYS_2",
    "MSH_GATE_TOTEM_PLINTHE_PHYS_3",
    "MSH_O_ARK",
    "MSH_O_ARK_DRY_DOCK",
    "MSH_O_ARK_WRECK",
    "MSH_O_AXE",
    "MSH_O_BAG",
    "MSH_O_BALL",
    "MSH_O_BELLTOWER",
    "MSH_O_BOX_FRAME",
    "MSH_O_BRANCH_EVERGREEN_INHAND",
    "MSH_O_BRANCH_FRUIT_INHAND",
    "MSH_O_BRANCH_HARDWOOD_INHAND",
    "MSH_O_BURNT_TREE",
    "MSH_O_CAULDRON",
    "MSH_O_CHAMPI",
    "MSH_O_CREATURE_TURD",
    "MSH_O_CROOK",
    "MSH_O_FISHINGROD",
    "MSH_O_FLATROCK_CHALK",
    "MSH_O_FLATROCK_LIMESTONE",
    "MSH_O_FLATROCK_SANDSTONE",
    "MSH_O_FLATROCK_VOLCANIC",
    "MSH_O_FLOWER_BED_1",
    "MSH_O_FLOWER_BED_2",
    "MSH_O_GATE_TOTEM_APE",
    "MSH_O_GATE_TOTEM_BLANK",
    "MSH_O_GATE_TOTEM_COW",
    "MSH_O_GATE_TOTEM_PLINTHE",
    "MSH_O_GATE_TOTEM_TIGER",
    "MSH_O_HAMMER",
    "MSH_O_INFO_SIGN",
    "MSH_O_JAPN_STONETHING",
    "MSH_O_LARGE_FISH_DEAD",
    "MSH_O_LIGHT_BULB",
    "MSH_O_LOGS_INHAND",
    "MSH_O_LONGROCK_CHALK",
    "MSH_O_LONGROCK_LIMESTONE",
    "MSH_O_LONGROCK_SANDSTONE",
    "MSH_O_LONGROCK_VOLCANIC",
    "MSH_O_MAGIC_MUSHROOM",
    "MSH_O_MALLET_HEAVY",
    "MSH_O_ROCK_CHALK",
    "MSH_O_ROCK_LIMESTONE",
    "MSH_O_ROCK_SANDSTONE",
    "MSH_O_ROCK_VOLCANIC",
    "MSH_O_SAW",
    "MSH_O_SCYTHE",
    "MSH_O_SHARPROCK_CHALK",
    "MSH_O_SHARPROCK_LIMESTONE",
    "MSH_O_SHARPROCK_SANDSTONE",
    "MSH_O_SHARPROCK_VOLCANIC",
    "MSH_O_SKULL_TOTEM",
    "MSH_O_SPADE",
    "MSH_O_SQUAREROCK_CHALK",
    "MSH_O_SQUAREROCK_LIMESTONE",
    "MSH_O_SQUAREROCK_SANDSTONE",
    "MSH_O_SQUAREROCK_VOLCANIC",
    "MSH_O_TICKERTAPE",
    "MSH_O_TOADSTOOL",
    "MSH_O_TOMBSTONE",
    "MSH_O_TOWNLIGHT",
    "MSH_O_TOY_BALL",
    "MSH_O_TOY_BOWLING_BALL",
    "MSH_O_TOY_CUDDLY",
    "MSH_O_TOY_DIE",
    "MSH_O_TOY_SKITTLE",
    "MSH_O_WHEAT_ENCLOSURE",
    "MSH_O_WHEAT_INHAND",
    "MSH_O_WOOD_INHAND",
    "MSH_REWARD_CHEST_EXPLODE",
    "MSH_SCULPTURE_IN_PROGRESS",
    "MSH_SINGING_STONE_CENTER",
    "MSH_SINGING_STONE",
    "MSH_IDOL_BUILDER",
    "MSH_NEW_SHAOLIN",
    "MSH_P_AMCN_F_A_1",
    "MSH_P_AMCN_F_A_2",
    "MSH_P_AMCN_F_A_3",
    "MSH_P_AMCN_M_A_1",
    "MSH_P_AMCN_M_A_2",
    "MSH_P_AMCN_M_A_3",
    "MSH_P_ANIMAL_BREEDER",
    "MSH_P_ANIMAL_TRAINER",
    "MSH_P_AZTC_F_A_1",
    "MSH_P_AZTC_F_A_2",
    "MSH_P_AZTC_F_A_3",
    "MSH_P_AZTC_LEADER",
    "MSH_P_AZTC_M_A_1",
    "MSH_P_AZTC_M_A_2",
    "MSH_P_AZTC_M_A_3",
    "MSH_P_BANDIT",
    "MSH_P_BOY_BLACK_1",
    "MSH_P_BOY_BLACK_2",
    "MSH_P_BOY_BLACK_3",
    "MSH_P_BOY_ORIENTAL_1",
    "MSH_P_BOY_ORIENTAL_2",
    "MSH_P_BOY_ORIENTAL_3",
    "MSH_P_BOY_TAN_1",
    "MSH_P_BOY_TAN_2",
    "MSH_P_BOY_TAN_3",
    "MSH_P_BOY_WHITE",
    "MSH_P_BOY_WHITE_1",
    "MSH_P_BOY_WHITE_2",
    "MSH_P_BOY_WHITE_3",
    "MSH_P_CELT_FOOTBALLER",
    "MSH_P_CELT_F_A_1",
    "MSH_P_CELT_F_A_2",
    "MSH_P_CELT_F_A_3",
    "MSH_P_CELT_M_A_1",
    "MSH_P_CELT_M_A_2",
    "MSH_P_CELT_M_A_3",
    "MSH_P_CRUSADER",
    "MSH_P_CULT_PRIEST",
    "MSH_P_CULT_PRIESTESS",
    "MSH_P_EGPT_F_A_1",
    "MSH_P_EGPT_F_A_2",
    "MSH_P_EGPT_F_A_3",
    "MSH_P_EGPT_M_A_1",
    "MSH_P_EGPT_M_A_2",
    "MSH_P_EGPT_M_A_3",
    "MSH_P_EGPT_M_B_1",
    "MSH_P_EGPT_M_B_2",
    "MSH_P_ENGINEER",
    "MSH_P_GIRL_BLACK_1",
    "MSH_P_GIRL_BLACK_2",
    "MSH_P_GIRL_BLACK_3",
    "MSH_P_GIRL_ORIENTAL_1",
    "MSH_P_GIRL_ORIENTAL_2",
    "MSH_P_GIRL_ORIENTAL_3",
    "MSH_P_GIRL_TAN_1",
    "MSH_P_GIRL_TAN_2",
    "MSH_P_GIRL_TAN_3",
    "MSH_P_GIRL_WHITE",
    "MSH_P_GIRL_WHITE_1",
    "MSH_P_GIRL_WHITE_2",
    "MSH_P_GIRL_WHITE_3",
    "MSH_P_GREK_F_A_1",
    "MSH_P_GREK_F_A_2",
    "MSH_P_GREK_F_A_3",
    "MSH_P_GREK_M_A_1",
    "MSH_P_GREK_M_A_2",
    "MSH_P_GREK_M_A_3",
    "MSH_P_HERMIT",
    "MSH_P_HIPPY",
    "MSH_P_IDOL_BUILDER",
    "MSH_P_INTRO_F",
    "MSH_P_INTRO_M",
    "MSH_P_JAPANESE_F_A_2",
    "MSH_P_JAPANESE_F_A_3",
    "MSH_P_JAPANESE_M_A_1",
    "MSH_P_JAPANESE_M_A_2",
    "MSH_P_JAPANESE_M_A_3",
    "MSH_P_JAPN_F_A_1",
    "MSH_P_JAPN_F_A_2",
    "MSH_P_JAPN_F_A_3",
    "MSH_P_JAPN_M_A_1",
    "MSH_P_JAPN_M_A_2",
    "MSH_P_JAPN_M_A_3",
    "MSH_P_NOMAD",
    "MSH_P_NORS_FOOTBALLER",
    "MSH_P_NORS_F_A_1",
    "MSH_P_NORS_F_A_2",
    "MSH_P_NORS_F_A_3",
    "MSH_P_NORS_M_A_1",
    "MSH_P_NORS_M_A_2",
    "MSH_P_NORS_M_A_3",
    "MSH_P_NORS_SAILOR",
    "MSH_P_PIED_PIPER",
    "MSH_P_SAILOR_ACCORDIAN",
    "MSH_P_SCULPTOR",
    "MSH_P_SHAOLIN_MONK",
    "MSH_P_SHEPERD",
    "MSH_P_SKELETON_F",
    "MSH_P_SKELETON_M",
    "MSH_P_TIBETAN_F_A_2",
    "MSH_P_TIBETAN_F_A_3",
    "MSH_P_TIBETAN_M_A_1",
    "MSH_P_TIBETAN_M_A_2",
    "MSH_P_TIBETAN_M_A_3",
    "MSH_P_TIBT_F_A_1",
    "MSH_P_TIBT_F_A_2",
    "MSH_P_TIBT_F_A_3",
    "MSH_P_TIBT_M_A_1",
    "MSH_P_TIBT_M_A_2",
    "MSH_P_TIBT_M_A_3",
    "MSH_P_TIBT_M_B_1",
    "MSH_P_TIBT_M_B_2",
    "MSH_CREED",
    "MSH_S_BLAST_CONE",
    "MSH_S_BLAST_CENTRE",
    "MSH_S_BLAST_INNER",
    "MSH_S_BLAST_OUTER",
    "MSH_S_COLUMN",
    "MSH_S_FIREBALL_TAIL",
    "MSH_S_HEAL_MESH",
    "MSH_S_GRAIN_PILE",
    "MSH_S_HORN_OF_PLENTY",
    "MSH_S_PHILE",
    "MSH_S_PHILE_ANGRY",
    "MSH_S_PHILE_BIG",
    "MSH_S_PHILE_FAT",
    "MSH_S_PHILE_FREEZE",
    "MSH_S_PHILE_FRIGHTEN",
    "MSH_S_PHILE_HUNGRY",
    "MSH_S_PHILE_ILL",
    "MSH_S_PHILE_INVISIBLE",
    "MSH_S_PHILE_ITCHY",
    "MSH_S_PHILE_LOVE",
    "MSH_S_PHILE_SMALL",
    "MSH_S_PHILE_STRONG",
    "MSH_S_PHILE_THIN",
    "MSH_S_PHILE_THIRSTY",
    "MSH_S_PHILE_TIRED",
    "MSH_S_PHILE_WEAK",
    "MSH_S_RAIN_CONE",
    "MSH_S_SHIELDMAGICLOWPOLY",
    "MSH_S_SOLID_SHIELD",
    "MSH_S_SPELLBALLSURFACE02",
    "MSH_S_SKULL_ICON",
    "MSH_S_SPELL_CREATOR",
    "MSH_S_SPELL_DISPENSER",
    "MSH_S_VORTEXCYLINDER",
    "MSH_S_ZCHEATBOX",
    "MSH_S_PULSE_IN",
    "MSH_S_PULSE_OUT",
    "MSH_A_WORM",
    "MSH_B_DUMMY_CITADEL",
    "MSH_Z_APPLE_BARREL",
    "MSH_Z_ARROW",
    "MSH_Z_SPELLROCK01",
    "MSH_Z_SPELLROCK02",
    "MSH_T_COPSE",
    "MSH_T_COPSE_A",
    "MSH_T_BEECH",
    "MSH_T_BIRCH",
    "MSH_T_BUSH",
    "MSH_T_BUSH_A",
    "MSH_T_BUSH_B",
    "MSH_T_CEDAR",
    "MSH_T_CONIFER",
    "MSH_T_CONIFER_A",
    "MSH_T_CYPRESS",
    "MSH_T_CYPRESS_A",
    "MSH_T_HEDGE",
    "MSH_T_HEDGE_A",
    "MSH_T_OAK",
    "MSH_T_OAK_A",
    "MSH_T_OLIVE",
    "MSH_T_PALM",
    "MSH_T_PALM_A",
    "MSH_T_PALM_B",
    "MSH_T_PALM_C",
    "MSH_T_PINE",
    "MSH_T_RICE",
    "MSH_T_ROOTS",
    "MSH_T_ROOTS_PILE",
    "MSH_T_WHEAT",
    "MSH_T_WHEAT_INFIELD",
    "MSH_U_AXE",
    "MSH_U_BAG",
    "MSH_U_BALL",
    "MSH_U_BENCH",
    "MSH_U_BUCKET",
    "MSH_U_BUCKET02",
    "MSH_U_CART",
    "MSH_U_CHEST",
    "MSH_U_CHEST_TOP",
    "MSH_U_CROOK",
    "MSH_U_FISHING_ROD",
    "MSH_U_FRAME",
    "MSH_U_FRAME_SKIN",
    "MSH_U_HAMMER",
    "MSH_U_MALLET_HEAVY",
    "MSH_U_SAW",
    "MSH_U_SCYTHE",
    "MSH_U_SPADE",
    "MSH_U_STOOL",
    "MSH_U_STOOL01",
    "MSH_U_TABLE",
    "MSH_U_TROUGH",
    "MSH_U_WASHING_LINE_AMCN",
    "MSH_U_WASHING_LINE_AZTC",
    "MSH_U_WASHING_LINE_CELT",
    "MSH_U_WASHING_LINE_EGPT",
    "MSH_U_WASHING_LINE_GREK",
    "MSH_U_WASHING_LINE_JAPN",
    "MSH_U_WASHING_LINE_NORS",
    "MSH_U_WASHING_LINE_TIBT",
    "MAX_COUNT_3D_MESHES"
};



//
// Functions
//

//
// Shutdown Archive
//
void ShutG3D( )
{
	if( gpG3DData )
	{
		delete[] gpG3DData;
		gpG3DData = NULL;
	}

	if( gpHiResTextures )
	{
		delete[] gpHiResTextures;
		gpHiResTextures = NULL;
	}

	if( gpG3DBinds )
	{
		glDeleteTextures( gnG3DBinds, gpG3DBinds );
		delete[] gpG3DBinds;
		gpG3DBinds = NULL;

	}
	if ( gpDeCompressedTextures)
	{
		for(int i=0;i<gnG3DBinds;i++)
		{
			if(gpDeCompressedTextures[i])
				delete gpDeCompressedTextures[i];
		}
		delete gpDeCompressedTextures;
	}
	gpMeshes	= NULL;
	gG3DSize	= 0;
	gnG3DBinds	= 0;

	gpLoadFromG3D->disable( );
	gpLoadFromG3D2->disable( );
}



//
// Load L3D From G3D
//
void L3DFromG3D( DWORD inMshIndex, DWORD inModelIndex )
{
	printf( "Loading %s...\n", gG3DStringList[inMshIndex] );

	assert( inMshIndex < gpMeshes->mnMeshes );
	assert( inMshIndex > 0 );

	L3DfromMem( (char*) gpMeshes + ((DWORD*)((gpMeshes+1)))[inMshIndex], inModelIndex );
}



//
// Upload HiRes Texture and returns bind
//
void UploadG3DTextures( void )
{
	assert( gpHiResTextures );
	assert( gpG3DBinds );

	// 
	// Upload LoResTextures
	// 
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

	int		tex;
	for( tex=0 ; tex<gnG3DBinds ; ++tex )
	{
		glBindTexture( GL_TEXTURE_2D, gpG3DBinds[tex] );

		int		height = gpHiResTextures[tex]->mDXTexture.mSurfDesc.dwHeight,
				width  = gpHiResTextures[tex]->mDXTexture.mSurfDesc.dwWidth;
		
		if( gpHiResTextures[tex]->mType == 2 )
		{
			if( glCompressedTexImage2DARB )
			{
				glCompressedTexImage2DARB(	GL_TEXTURE_2D, 0, GL_COMPRESSED_RGBA_S3TC_DXT3_EXT, 
											width, height, 0, ((width+3)/4)*((height+3)/4)*16, (((byte*)gpHiResTextures[tex]+sizeof(G3D_HiResTexture))) );
			}
			else
			{
			//Cryect - Decompressing routine for non-compliant cards
				gpDeCompressedTextures[tex] = new byte[height*width*4];
				DecompressDXT3((((byte*)gpHiResTextures[tex]+sizeof(G3D_HiResTexture))), gpDeCompressedTextures[tex],height,width);
				gluBuild2DMipmaps( GL_TEXTURE_2D, GL_RGBA, 256, 256, GL_RGBA, GL_UNSIGNED_BYTE, gpDeCompressedTextures[tex] );
				glTexParameteri( GL_TEXTURE_2D,GL_TEXTURE_WRAP_S, GL_REPEAT );
				glTexParameteri( GL_TEXTURE_2D,GL_TEXTURE_WRAP_T, GL_REPEAT );
				glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);
				glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
			}

		}
		else
		{
			if( glCompressedTexImage2DARB )
			{
				glCompressedTexImage2DARB(	GL_TEXTURE_2D, 0, GL_COMPRESSED_RGBA_S3TC_DXT1_EXT, 
											width, height, 0, ((width+3)/4)*((height+3)/4)*8, (((byte*)gpHiResTextures[tex]+sizeof(G3D_HiResTexture))) );
			}
			else
			{
			//Cryect - Decompressing routine for non-compliant cards
				gpDeCompressedTextures[tex] = new byte[height*width*4];
				DecompressDXT1((((byte*)gpHiResTextures[tex]+sizeof(G3D_HiResTexture))), gpDeCompressedTextures[tex],height,width);
				gluBuild2DMipmaps( GL_TEXTURE_2D, GL_RGBA, 256, 256, GL_RGBA, GL_UNSIGNED_BYTE, gpDeCompressedTextures[tex] );

				glTexParameteri( GL_TEXTURE_2D,GL_TEXTURE_WRAP_S, GL_REPEAT );
				glTexParameteri( GL_TEXTURE_2D,GL_TEXTURE_WRAP_T, GL_REPEAT );
				glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);
				glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
			}
		}
	}

}



//
// Loads a G3D File, enables Controls, sets filename and so on
//
void LoadG3D( )
{
	ShutG3D( );

	if(!LoadDialog( "ModelView: LoadG3D", "Mesh Archive (*.G3D)\0*.G3D\0All Files(*.*)\0*.*\0\0" ))
		return;

	



	//
	// Safe Read File
	//
	assert( gpFilename );

	strcpy( gpG3DFilename, gpFilename );
	printf( "\nLoading Archive %s ...\n\n", gpFilename );

	FILE		*fp;
	DWORD		size;
	
	fp = fopen( gpFilename, "rb" );

	if( !fp )
	{
		printf( "ERROR : Unable to Open Specified File %s\n", gpFilename );
		ShutG3D( );
		return;
	}

	fseek( fp, 0, SEEK_END );
	size = ftell( fp );
	fseek( fp, 0, SEEK_SET );

	assert( size );
	assert( !gpG3DData );

	gpG3DData = new char[size];
	gG3DSize  = size;

	assert( gpG3DData );	
	
	fread( gpG3DData, size, 1, fp );
	
	fclose( fp );



	//
	// Check
	//
	if( (gpG3DData[0] != 'L') &&
		(gpG3DData[1] != 'i') &&
		(gpG3DData[2] != 'O') &&
		(gpG3DData[3] != 'n') &&
		(gpG3DData[4] != 'H') &&
		(gpG3DData[5] != 'e') &&
		(gpG3DData[6] != 'A') &&
		(gpG3DData[7] != 'd'))
	{
		printf( "ERROR : Invalid Header Id, should be \"LiOnHeAd\" is \"%c%c%c%c%c%c%c%c\"\n", 
				gpG3DData[0], gpG3DData[1], gpG3DData[2], gpG3DData[3], gpG3DData[4], gpG3DData[5], gpG3DData[6], gpG3DData[7] );
		ShutG3D( );
		return;
	}



	//
	// Setup Pointers
	//
	LH_BlockHeader		*pBlock = (LH_BlockHeader *)(gpG3DData+8); // skip LiOnHeAd

	

	//
	// Read Blocks
	//
	while( (char *)pBlock < gpG3DData+size )
	{	

		if( !strcmp( pBlock->mnBlockName, "MESHES" ) )
		{
			//
			// Error Checking
			//
			gpMeshes = (G3D_Meshes	*)(pBlock + 1);

			if( gpMeshes->mnID != 'CJKM' ) // Hello Jean Claude
			{
				printf( "ERROR : No Meshes ID MKJC !!!\n" );
				ShutG3D( );
				return;
			}
			
			if( gpMeshes->mnMeshes != MAX_COUNT_3D_MESHES )
			{
				printf( "ERROR : No Meshes ID MKJC !!!\n" );
				ShutG3D( );
				return;
			}

			//
			// Add to List
			//
			
			DWORD	item;
			for( item=0 ; item<gpMeshes->mnMeshes ; ++item )
				gpLoadFromG3D->add_item( item, gG3DStringList[item] );
		}
		else
		if( !strcmp( pBlock->mnBlockName, "INFO" ) )
		{
			//
			// LoRes Texture
			//
			printf( "Info Block\n" );
		}
		else
		if( !strncmp( pBlock->mnBlockName, "LOW", 3 ) )
		{
			//
			// LoRes Texture
			//
			printf( "LoRes Texture\n" );
		}
		else
		{
			//
			// HiRes Texture
			//
			G3D_HiResTexture		*pTex = (G3D_HiResTexture *)(pBlock + 1);
			DWORD					check;

			sscanf( pBlock->mnBlockName, "%x", &check );

			assert( check == pTex->mID );

			if( !gpHiResTextures )
			{
				gpHiResTextures = (G3D_HiResTexture**)	new DWORD[pTex->mID];

				if( !glCompressedTexImage2DARB )
					gpDeCompressedTextures = (byte**)	new DWORD[pTex->mID];	

				gpG3DBinds		= (unsigned int *)		new DWORD[pTex->mID];
				glGenTextures( pTex->mID, gpG3DBinds );
				gnG3DBinds		= pTex->mID;
			}

			assert( pTex->mID <= (unsigned int) gnG3DBinds );

			gpHiResTextures[check-1] = pTex;

		}

		pBlock  = (LH_BlockHeader *)((char*)pBlock+pBlock->mnBlockSize+36);
	}

	UploadG3DTextures( );

	gpLoadFromG3D->enable( );
	gpLoadFromG3D2->set_int_limits( 0, MAX_COUNT_3D_MESHES-1 );
	gpLoadFromG3D2->enable( );
}



