// Copyright(c) 2oo1 by Mental Vortex
#ifndef _G3D_H_
#define _G3D_H_
// 
// Description:
// 
// Lionhead 3D File Archive .g3d
// 

//
// Includes
//
#include <ddraw.h>						// for DXT3


//
// Mesh List Header
//
// followed by
//
//	DWORD				mpMeshes[mnMeshes]	// an Array of Pointers (local) to mMeshes
//
//	L3DFile				mMeshes[mnMeshes]	// Meshes
//
struct G3D_Meshes
{
	DWORD				mnID;				// always MKJC... JC = Jean-Claude Cottier
	DWORD				mnMeshes;			// Number of Meshes = MAX_COUNT_3D_MESHES from "AllMeshes.h"
};


//
// Texture Header Used by both, HiRes and LoRes
//
struct G3D_DXTexture
{
	DWORD				mSize;				// Size of this mData + LH_CompressedTexture
	DDSURFACEDESC2		mSurfDesc;			// Meshes
};


//
// HiResTexture
//
struct G3D_HiResTexture
{
	DWORD				mSize;				// Size of this 
	DWORD				mID;				// gottabe same as %x in Header Name
	DWORD				mType;				// 1 means DXT1 Texture (size different, too)
											// 2 means DXT3 Texture (size different, too)
	G3D_DXTexture		mDXTexture;
};


#endif //_G3D_H_