// Copyright(c) 2oo1 by Darkyoda and MENTAL VORTEX

// 
// Description:
// 
// Black and White L3D File Loader
// 
//
// 
// 




//
// Comments :
//
// 16.April
// mlinehan : New Morphcode
//
/*
	Here ya go....
	Here are the files I modified from the 2.5 source to implement Delta
	Vertex Morphing. It works MUCH better now. You can now combine 75%
	Good, with 20% strong with 80% Fat!!!!!!

	Excuse my general clunkiness with C++. Most everything I do is embeded
	in hard realtime systems so I avoid C++ like the plague. It's just not
	suited to embedded real time systems.

	I only had to implement operator- in class Vec2, and Vec3, and modify
	the XformVertex function a bit.

	Enjoy!
*/
//
// 15.April
// DY : Created this File
//
//
//



// Includes
#include			"main.h"




//
// OpenDialog
//
int LoadDialog( char *inTitle, char *inFilter )
{
	OPENFILENAME    OpenFileName;

	OpenFileName.lStructSize       = sizeof(OPENFILENAME);     
	OpenFileName.hwndOwner         = GetFocus( );    
	OpenFileName.hInstance         = GetModuleHandle( NULL );   
	OpenFileName.lpstrFilter       = inFilter;    
	OpenFileName.lpstrCustomFilter = (LPTSTR) NULL;   
	OpenFileName.nMaxCustFilter    = 0L;    
	OpenFileName.nFilterIndex      = 1L;    
	OpenFileName.lpstrFile         = gpFilename; 
    OpenFileName.nMaxFile          = 512; 
    OpenFileName.lpstrFileTitle    = NULL;  
	OpenFileName.nMaxFileTitle     = 0;   
	OpenFileName.lpstrInitialDir   = NULL;    
	OpenFileName.lpstrTitle        = inTitle; 
	OpenFileName.nFileOffset       = 0;   
	OpenFileName.nFileExtension    = 0;  
	OpenFileName.lpstrDefExt       = NULL; // No default extension     
	OpenFileName.lCustData         = 0;     
	OpenFileName.Flags =	OFN_SHOWHELP | OFN_PATHMUSTEXIST |                          
							OFN_FILEMUSTEXIST | OFN_HIDEREADONLY |                          
							OFN_EXPLORER | OFN_LONGNAMES;        
	
	return (GetOpenFileName(&OpenFileName));
}



//
// SaveDialog
// Displays a dialog and saves the result in gpFilename
//
int SaveDialog( char *inTitle, char *inFilter )
{
	OPENFILENAME    OpenFileName;

	OpenFileName.lStructSize       = sizeof(OPENFILENAME);     
	OpenFileName.hwndOwner         = GetFocus( );    
	OpenFileName.hInstance         = GetModuleHandle( NULL );   
	OpenFileName.lpstrFilter       = inFilter;    
	OpenFileName.lpstrCustomFilter = (LPTSTR) NULL;   
	OpenFileName.nMaxCustFilter    = 0L;    
	OpenFileName.nFilterIndex      = 1L;    
	OpenFileName.lpstrFile         = gpFilename; 
    OpenFileName.nMaxFile          = 512; 
    OpenFileName.lpstrFileTitle    = NULL;  
	OpenFileName.nMaxFileTitle     = 0;   
	OpenFileName.lpstrInitialDir   = NULL;    
	OpenFileName.lpstrTitle        = inTitle; 
	OpenFileName.nFileOffset       = 0;   
	OpenFileName.nFileExtension    = 0;  
	OpenFileName.lpstrDefExt       = NULL; // No default extension     
	OpenFileName.lCustData         = 0;     
	OpenFileName.Flags =	OFN_SHOWHELP | OFN_PATHMUSTEXIST |                          
							OFN_FILEMUSTEXIST | OFN_HIDEREADONLY |                          
							OFN_EXPLORER | OFN_LONGNAMES;      
	
	return GetSaveFileName(&OpenFileName);    
}

		

//
// Loads a Model
//
void LoadModel( int inIndex )
{
	assert( inIndex >= 0 );
	assert( inIndex <  4 );

	if(!LoadDialog( "ModelView: LoadModel", "Models(*.L3D)\0*.L3D\0All Files(*.*)\0*.*\0\0" ) )
		return;

	ReadL3D( inIndex );
}



//
// Save the Model
//
void SaveModel( int inIndex )
{
	assert( inIndex >= 0 );
	assert( inIndex <  4 );

	if(!gpModels[inIndex].mLoaded)
		return;

	if(!SaveDialog( "ModelView: SaveModel", "Models(*.L3D)\0*.L3D\0All Files(*.*)\0*.*\0\0" ) )
		return;


	FILE *fp = fopen( gpFilename, "wb" );

	if( !fp )
	{
		printf( "Couldn't open file %s for writing\n", gpFilename );
		return;
	}

	fwrite( gpModels[inIndex].mBuffer, gpModels[inIndex].mSize, 1, fp );

	fclose( fp );

	printf( "Model Saved\n" );
}



//
// Saves the Skin of Model %i
//
void SaveTexture( int inIndex )
{
	assert( inIndex >= 0 );
	assert( inIndex <  4 );

	if(!gpModels[inIndex].mLoaded)
		return;

	if(!gpModels[inIndex].mnSkins)
		return;

	gpFilename[strlen(gpFilename)-4] = 0; // cut .l3d

	if(!SaveDialog( "ModelView: SaveTexture", "Targa(*.TGA)\0*.TGA\0All Files(*.*)\0*.*\0\0" ) )
		return;


	char				*pRawData		= gpModels[inIndex].mBuffer;
	LH3D_BaseHeader		*pBaseHeader	= (LH3D_BaseHeader*) pRawData;
	byte				*pSkinPointer	= (byte*)	( pRawData + pBaseHeader->mSkinOffset );

	TGA_SaveRGBA4444( pSkinPointer, gpFilename, gpModels[inIndex].mnSkins );
}



//
// Load the Skin %i for Model %i
//
void LoadTexture( int inModelIndex, int inSkinIndex )
{
	assert( inModelIndex >= 0 );
	assert( inModelIndex <  4 );

	if(!gpModels[inModelIndex].mLoaded)
		return;

	if( gpModels[inModelIndex].mnSkins<inSkinIndex+1 )
		return;

	char				*pRawData		= gpModels[inModelIndex].mBuffer;
	LH3D_BaseHeader		*pBaseHeader	= (LH3D_BaseHeader*) pRawData;
	byte				*pSkinPointer	= (byte*)	( pRawData + pBaseHeader->mSkinOffset );

	if( pBaseHeader->mSkinOffset > (DWORD) gpModels[inModelIndex].mSize )
		return;

	if(!LoadDialog( "ModelView: LoadTexture", "Targe(*.TGA)\0*.TGA\0All Files(*.*)\0*.*\0\0" ))
		return;

	//
	// Converting RGBA8888 to 4444, storing into modelbuffer, then converting back to RGBA8888
	// ensures that the users sees exactly whats stored into the file.
	//

	pSkinPointer += (inSkinIndex+1)*4/*SkinID*/ + inSkinIndex*256*256*2;

	TGA_LoadRGBA( pSkinPointer, gpFilename );

	byte	*b;

	b = pSkinPointer;

	byte	imgbuf[256*256*4];
	byte	*p					= imgbuf;						// Target Pointer

	//
	// Convert the Textures to BGRA8888 Format
	//
	int		i;
	for( i=0 ; i<65536 ; ++i )
	{
		p[2] = (   *b         & 15) * 17;
		p[1] = (( (*b++)>>4 ) & 15) * 17;
		p[0] = (   *b         & 15) * 17;
		p[3] = (( (*b++)>>4 ) & 15) * 17;

		p+=4;
	}

	glDeleteTextures( 1, (unsigned int*)&gpModels[inModelIndex].mpSkinBinds[inSkinIndex] );

	// 
	// Upload Texture
	// 
	glBindTexture( GL_TEXTURE_2D, gpModels[inModelIndex].mpSkinBinds[inSkinIndex] );

	gluBuild2DMipmaps( GL_TEXTURE_2D, GL_RGBA, 256, 256, GL_RGBA, GL_UNSIGNED_BYTE, imgbuf );

	glTexParameteri( GL_TEXTURE_2D,GL_TEXTURE_WRAP_S, GL_REPEAT );
	glTexParameteri( GL_TEXTURE_2D,GL_TEXTURE_WRAP_T, GL_REPEAT );
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
}



//
// Shutdown Model %i
//
void Shutdown( int inIndex )
{
	if( !gpModels[inIndex].mLoaded )
		return;

	if( gpModels[inIndex].mLoaded == 1)
	if( gpModels[inIndex].mBuffer )
	{
		delete[] gpModels[inIndex].mBuffer;
		gpModels[inIndex].mBuffer = NULL;
	}

	//
	// Free Memory and reset Vars
	//
	gpModels[inIndex].mLoaded		= MODEL_NONE;

	if( gpModels[inIndex].mnSkins )
	{
		glDeleteTextures( gpModels[inIndex].mnSkins, (unsigned int *)gpModels[inIndex].mpSkinBinds );
		delete[] gpModels[inIndex].mpSkinBinds;
		delete[] gpModels[inIndex].mpSkinIDs;
		gpModels[inIndex].mpSkinBinds = NULL;
		gpModels[inIndex].mpSkinIDs   = NULL;
	}

	int		mesh;
	for( mesh=0 ; mesh<gpModels[inIndex].mnMeshes ; ++mesh )
	{
		// The Bones point to mBuffer, so don't delete
		gpModels[inIndex].mpMeshes[mesh].mnBones = 0;
		gpModels[inIndex].mpMeshes[mesh].mpBones = NULL;
		if( gpModels[inIndex].mpMeshes[mesh].mpXformedBones )
		{
			delete[] gpModels[inIndex].mpMeshes[mesh].mpXformedBones;
			gpModels[inIndex].mpMeshes[mesh].mpXformedBones = NULL;
		}

		int		submesh;
		for( submesh=0 ; submesh<gpModels[inIndex].mpMeshes[mesh].mnSubModels ; ++submesh )
		{
			gpModels[inIndex].mpMeshes[mesh].mpSubModels[submesh].mnTriangles = 0;

			gpModels[inIndex].mpMeshes[mesh].mpSubModels[submesh].mnVertices = 0;
			if( gpModels[inIndex].mpMeshes[mesh].mpSubModels[submesh].mpVertices )
			{
				delete[] gpModels[inIndex].mpMeshes[mesh].mpSubModels[submesh].mpVertices;
				gpModels[inIndex].mpMeshes[mesh].mpSubModels[submesh].mpVertices = NULL;
			}

			if( gpModels[inIndex].mpMeshes[mesh].mpSubModels[submesh].mpXformedVertices )
			{
				delete[] gpModels[inIndex].mpMeshes[mesh].mpSubModels[submesh].mpXformedVertices;
				gpModels[inIndex].mpMeshes[mesh].mpSubModels[submesh].mpXformedVertices = NULL;
			}
		}

		if( gpModels[inIndex].mpMeshes[mesh].mpSubModels )
		{
			delete[] gpModels[inIndex].mpMeshes[mesh].mpSubModels;
			gpModels[inIndex].mpMeshes[mesh].mpSubModels = NULL;
		}

		gpModels[inIndex].mpMeshes[mesh].mnSubModels = 0;
	}

	gpModels[inIndex].mnSkins		= 0;
	

	//
	// Disable Controls
	//
	if( inIndex == 0 )
	{
		gpSavetex->disable( );
		int		skin;
		for( skin=0 ; skin<11 ; ++skin )
			gpLoadtex[skin]->disable( );

		gpLoadANM->disable( );

		ShutANM( );
	}

	if( inIndex == 1 )
		gCAlign->disable( );

	if( inIndex == 2 )
		gCStrength->disable( );

	if( inIndex == 3 )
		gCFat->disable( );
}



//
// Reads a L3D from Memory
//
void L3DfromMem( void *inSrc, int inIndex)
{
	assert( inSrc );



	LH3D_Model *Model = &gpModels[inIndex];

	if( inIndex && !gpModels[0].mLoaded )
	{
		printf( "Load Base Model First\n" );
		return;
	}

	//
	// Shutdown if still open
	//
	Shutdown( inIndex );

	if( !inIndex )
	{
		Shutdown( 1 );Shutdown( 2 );Shutdown( 3 );
		gBaseChanged = 1;
		gpLoadANM->enable( );
	}

	gpSaveModel->enable( );
	Model->mLoaded			= 2;	



	char	*pRawData		= (char *)inSrc;

	//
	// Setup Important Pointers
	// and get Important Vars
	//
	LH3D_BaseHeader		*pBaseHeader	= (LH3D_BaseHeader*) pRawData;
	byte				*pSkinPointer	= (byte*)	( pRawData + pBaseHeader->mSkinOffset );
	DWORD				*pMeshes		= (DWORD*)	( pRawData + pBaseHeader->mMeshListOffset );

	int					nSkins			= pBaseHeader->mnSkins;
	int					nMeshes			= pBaseHeader->mnMeshes;


	int					size			= pBaseHeader->mSkinOffset;
		



	//
	// Check if the File is valid
	//
	if( pBaseHeader->mID != '0D3L' )
	{
		printf( "Invalid File ID Tag\n\n" );
		Shutdown( inIndex );
		return;
	}
	


	//
	// Setup Model Structure
	//
	Model->mnSkins			= nSkins;
	Model->mnMeshes			= nMeshes;

	Model->mpMeshes			= new LH3D_SubModel[nMeshes];
	Model->mpSkinBinds		= new DWORD[nSkins];
	Model->mpSkinIDs		= new DWORD[nSkins];

	memset( Model->mpMeshes		, 0x00, sizeof(LH3D_SubModel)*nMeshes );
	memset( Model->mpSkinBinds	, 0x00, sizeof(DWORD)*nSkins );
	memset( Model->mpSkinIDs	, 0x00, sizeof(DWORD)*nSkins );

	printf( "%i Skins Blocks (RGBA4444 256x256)\n%i Meshes\n", nSkins, nMeshes );




	//
	// Perform some Validations
	//
	if( inIndex )
	{
		if( nMeshes != gpModels[0].mnMeshes )
		{
			printf( "Invalid Number of Meshes in Model\n" );
			Shutdown( inIndex );
			return;
		}
	}






	//
	// Read the Textures from File
	// 
	if( nSkins )
	if( pBaseHeader->mSkinOffset >= (DWORD) size )
	{
		memset( Model->mpSkinBinds, 0x00, nSkins*4 );
	}
	else
	{
		assert( 0 && "This shouldn't happen" );
	}




	
	//
	// Read Geometry Data
	//
	int			mesh;
	for( mesh=0 ; mesh<nMeshes ; ++mesh )
	{
		//
		// Again, Setup Pointers and Vars
		// 
		LH3D_SubModel*	pModel		= &Model->mpMeshes[mesh];

		LH3D_Mesh*		pMesh		= (LH3D_Mesh*)	( pRawData + pMeshes[mesh] );
		DWORD*			pSubMeshes	= (DWORD*)		( pRawData + pMesh->mSubMeshListOffset );
		LH3D_Bone*		pBones		= (LH3D_Bone*)	( pRawData + pMesh->mpBones );

		int				nSubMeshes	= pMesh->mnSubMeshes;
		int				nBones		= pMesh->mnBones;

		printf( "mnBones : %i\n", nBones );

		printf( " Hex Header : %02x %02x %02x %02x\n", pMesh->mUnk_1, pMesh->mUnk_2, pMesh->mUnk_3, pMesh->mUnk_4 );


		//
		// Setup Model Structure again
		//
		pModel->mnBones				= nBones;
		pModel->mpBones				= pBones;
		pModel->mpXformedBones		= new LH3D_Bone[nBones];

		pModel->mnSubModels			= nSubMeshes;
		pModel->mpSubModels			= new LH3D_GeoModel[nSubMeshes];

		pModel->mFlags				= LH3D_SubModel::FLAGS_NONE;

		if( pMesh->mUnk_2 & 0x20 )
			pModel->mFlags |= LH3D_SubModel::FLAGS_NODRAW;

		if( pMesh->mUnk_1 > 1 )
			pModel->mFlags |= LH3D_SubModel::FLAGS_BLEND;



		//
		// Compare to Base Model for Morphing
		//
		if( inIndex )
		{
			if( gpModels[0].mpMeshes[mesh].mnBones != nBones )
			{
				printf( "Invalid Number of Bones in Morphtarget\n" );
				Shutdown( inIndex );
				return;	
			}

			if( gpModels[0].mpMeshes[mesh].mnSubModels != nSubMeshes )
			{
				printf( "Invalid Number of Bones in Morphtarget\n" );
				Shutdown( inIndex );
				return;	
			}
		}




		//
		// Read the Vertex and Triangle Data
		//
		int		submesh;
		for( submesh=0 ; submesh<nSubMeshes ; ++submesh )
		{
			LH3D_GeoModel	*pGeo		= pModel->mpSubModels+submesh;

			LH3D_SubMesh	*pSubMesh	= (LH3D_SubMesh*)	( pRawData + pSubMeshes[submesh] );
			
			LH3D_Vertex		*pVertices  = (LH3D_Vertex*)	( pRawData + pSubMesh->mpVertices);
			LH3D_Triangle	*pTris		= (LH3D_Triangle*)	( pRawData + pSubMesh->mpTriangles);
			LH3D_BoneVert	*pBoneVert	= (LH3D_BoneVert*)	( pRawData + pSubMesh->mpBoneVertLUT);


			int				nVerts		= (int)	pSubMesh->mnVertices;
			int				nTris		= (int)	pSubMesh->mnTriangles;
			int				szBoneVert	= (int)	pSubMesh->mszBoneVertLUT;



			//
			// Get Skin
			//

			pGeo->mSkinIndex = pSubMesh->mSkinID-1;


			//
			// Copy info to Geometry Model
			// 
			pGeo->mnTriangles		= nTris;
			pGeo->mnVertices		= nVerts;
			pGeo->mpTriangles		= pTris;
			pGeo->mpVertices		= new LH3D_MemVertex[nVerts];
			pGeo->mpXformedVertices	= new LH3D_MemVertex[nVerts];


			//
			// Compare to Base Model for Morphing
			//
			if( inIndex )
			{	
				if( gpModels[0].mpMeshes[mesh].mpSubModels[submesh].mnTriangles != nTris )
				{
					printf( "Invalid Number of Triangles in Morphtarget\n" );
					Shutdown( inIndex );
					return;	
				}

				if( gpModels[0].mpMeshes[mesh].mpSubModels[submesh].mnVertices != nVerts )
				{
					printf( "Invalid Number of Vertices in Morphtarget\n" );
					Shutdown( inIndex );
					return;	
				}
			}



			//
			// Write Bone Indices
			//
			int		BoneVert;
			int		vertind = 0;
			for( BoneVert=0 ; BoneVert<szBoneVert ; ++BoneVert )
			{
				int vert;
				for( vert=0 ; vert<pBoneVert[BoneVert].mnVertices ; ++vert )
				{
					LH3D_MemVertex	*pVertex	= &pGeo->mpVertices[vertind];
		
					pVertex->mnBone = pBoneVert[BoneVert].mBoneIndex;
					++vertind;
				}
			}



			//
			// Copy Vertex Info
			//
			for( vertind=0 ; vertind<nVerts ; ++vertind )
			{
				LH3D_MemVertex	*pDst	= &pGeo->mpVertices[vertind];
				LH3D_MemVertex	*pDst2	= &pGeo->mpXformedVertices[vertind];
				LH3D_Vertex		*pSrc	= &pVertices[vertind];

				pDst2->mNormal		= pDst->mNormal		= pSrc->mNormal;
				pDst2->mPosition	= pDst->mPosition	= pSrc->mPosition;
				pDst2->mTexCoords	= pDst->mTexCoords	= pSrc->mTexCoords;
			}
		}
	}

	//
	// Enable Controls
	//

	if( inIndex == 1 )
		gCAlign->enable( );

	if( inIndex == 2 )
		gCStrength->enable( );

	if( inIndex == 3 )
		gCFat->enable( );
}



//
// Reads a L3D From File, and Creates Display Lists For Mesh Groups
//
void ReadL3D( int inIndex )
{
	LH3D_Model *Model = &gpModels[inIndex];

	if( inIndex && !gpModels[0].mLoaded )
	{
		printf( "Load Base Model First\n" );
		return;
	}

	gpSaveModel->enable( );


	



	//
	// Shutdown if still open
	//
	Shutdown( inIndex );

	if( !inIndex )
	{
		Shutdown( 1 );Shutdown( 2 );Shutdown( 3 );
		gBaseChanged = 1;
		gpLoadANM->enable( );
	}

	Model->mLoaded			= MODEL_LOADED;	



	//
	// Safe Read File
	//
	assert( gpFilename );

	strcpy( Model->mFilename, gpFilename );

	printf( "\nLoading Model %s ...\n\n", gpFilename );

	FILE		*fp;
	DWORD		size;
	
	fp = fopen( gpFilename, "rb" );

	if( !fp )
	{
		printf( "ERROR : Unable to Open Specified File %s\n", gpFilename );
		Shutdown( inIndex );
		return;
	}

	fseek( fp, 0, SEEK_END );
	size = ftell( fp );
	fseek( fp, 0, SEEK_SET );

	assert( size );
	assert( !Model->mBuffer );

	gpModels[inIndex].mBuffer = new char[size];
	gpModels[inIndex].mSize   = size;

	assert( Model->mBuffer );	
	
	fread( Model->mBuffer, size, 1, fp );
	
	fclose( fp );




	/////////////////
	// Convert the Raw Data to a Memory Model
	//

	char				*pRawData		= gpModels[inIndex].mBuffer;



	//
	// Setup Important Pointers
	// and get Important Vars
	//
	LH3D_BaseHeader		*pBaseHeader	= (LH3D_BaseHeader*) pRawData;
	byte				*pSkinPointer	= (byte*)	( pRawData + pBaseHeader->mSkinOffset );
	DWORD				*pMeshes		= (DWORD*)	( pRawData + pBaseHeader->mMeshListOffset );

	int					nSkins			= pBaseHeader->mnSkins;
	int					nMeshes			= pBaseHeader->mnMeshes;




	//
	// Check if the File is valid
	//
	if( pBaseHeader->mID != '0D3L' )
	{
		printf( "Invalid File ID Tag\n\n" );
		Shutdown( inIndex );
		return;
	}
	


	//
	// Setup Model Structure
	//
	Model->mnSkins			= nSkins;
	Model->mnMeshes			= nMeshes;

	Model->mpMeshes			= new LH3D_SubModel[nMeshes];
	Model->mpSkinBinds		= new DWORD[nSkins];
	Model->mpSkinIDs		= new DWORD[nSkins];

	memset( Model->mpMeshes		, 0x00, sizeof(LH3D_SubModel)*nMeshes );
	memset( Model->mpSkinBinds	, 0x00, sizeof(DWORD)*nSkins );
	memset( Model->mpSkinIDs	, 0x00, sizeof(DWORD)*nSkins );

	glGenTextures( nSkins, (unsigned int *)Model->mpSkinBinds );


	printf( "%i Skins Blocks (RGBA4444 256x256)\n%i Meshes\n", nSkins, nMeshes );




	//
	// Perform some Validations
	//
	if( inIndex )
	{
		if( nMeshes != gpModels[0].mnMeshes )
		{
			printf( "Invalid Number of Meshes in Model\n" );
			Shutdown( inIndex );
			return;
		}

#pragma TODO( "Check if this is an Issue" )

/*		if( nSkins != gpModels[0].mnSkins )
		{
			printf( "Invalid Number of Skins in Model\n" );
			Shutdown( inIndex );
			return;
		}*/
	}






	//
	// Read the Textures from File, Directly Upload them.
	// 

	if( pBaseHeader->mSkinOffset < size )
	if( nSkins )
	{
		byte		*b					= pSkinPointer;		// The pointer to the Source Data
		byte		imgbuf[4*256*256];						// Target Image Block

		//
		// If this is base, Enable buttons for texture storage, loading
		//
		if( !inIndex )
		{
			gpSavetex->enable( );
			int		skin;
			for( skin=0 ; skin<nSkins ; ++skin )
				gpLoadtex[skin]->enable( );
		}

		int skin;
		for( skin=0 ; skin<nSkins ; ++skin )
		{
			byte *p			= imgbuf;						// Target Pointer

			Model->mpSkinIDs[skin] = *(DWORD*)b;

			b+=4;

			//
			// Convert the Textures to BGRA8888 Format
			//
			int		i;
			for( i=0 ; i<65536 ; ++i )
			{
				p[2] = (*b & 15) * 17;
				p[1] = (( (*b++) >>4 ) & 15) * 17;
				p[0] = (*b & 15) * 17;
				p[3] = (( (*b++) >>4 ) & 15) * 17;

				p+=4;
			}


			// 
			// Upload Texture
			// 
			glBindTexture( GL_TEXTURE_2D, Model->mpSkinBinds[skin] );

			gluBuild2DMipmaps( GL_TEXTURE_2D, GL_RGBA, 256, 256, GL_RGBA, GL_UNSIGNED_BYTE, imgbuf );

			glTexParameteri( GL_TEXTURE_2D,GL_TEXTURE_WRAP_S, GL_REPEAT );
			glTexParameteri( GL_TEXTURE_2D,GL_TEXTURE_WRAP_T, GL_REPEAT );
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
		}
	}




	
	//
	// Read Geometry Data
	//
	int			mesh;
	for( mesh=0 ; mesh<nMeshes ; ++mesh )
	{
		//
		// Again, Setup Pointers and Vars
		// 
		LH3D_SubModel*	pModel		= &Model->mpMeshes[mesh];

		LH3D_Mesh*		pMesh		= (LH3D_Mesh*)	( pRawData + pMeshes[mesh] );
		DWORD*			pSubMeshes	= (DWORD*)		( pRawData + pMesh->mSubMeshListOffset );
		LH3D_Bone*		pBones		= (LH3D_Bone*)	( pRawData + pMesh->mpBones );

		int				nSubMeshes	= pMesh->mnSubMeshes;
		int				nBones		= pMesh->mnBones;

		printf( "mnBones : %i\n", nBones );


		//
		// Setup Model Structure again
		//
		pModel->mnBones				= nBones;
		pModel->mpBones				= pBones;
		pModel->mpXformedBones		= new LH3D_Bone[nBones];

		pModel->mnSubModels			= nSubMeshes;
		pModel->mpSubModels			= new LH3D_GeoModel[nSubMeshes];

		memset( pModel->mpSubModels, 0x00, sizeof(LH3D_GeoModel)*nSubMeshes );

		pModel->mFlags				= LH3D_SubModel::FLAGS_NONE;



		//
		// Compare to Base Model for Morphing
		//
		if( inIndex )
		{
			if( gpModels[0].mpMeshes[mesh].mnBones != nBones )
			{
				printf( "Invalid Number of Bones in Morphtarget\n" );
				Shutdown( inIndex );
				return;	
			}

			if( gpModels[0].mpMeshes[mesh].mnSubModels != nSubMeshes )
			{
				printf( "Invalid Number of Bones in Morphtarget\n" );
				Shutdown( inIndex );
				return;	
			}
		}




		//
		// Read the Vertex and Triangle Data
		//
		int		submesh;
		for( submesh=0 ; submesh<nSubMeshes ; ++submesh )
		{
			LH3D_GeoModel	*pGeo		= pModel->mpSubModels+submesh;

			LH3D_SubMesh	*pSubMesh	= (LH3D_SubMesh*)	( pRawData + pSubMeshes[submesh] );
			
			LH3D_Vertex		*pVertices  = (LH3D_Vertex*)	( pRawData + pSubMesh->mpVertices);
			LH3D_Triangle	*pTris		= (LH3D_Triangle*)	( pRawData + pSubMesh->mpTriangles);
			LH3D_BoneVert	*pBoneVert	= (LH3D_BoneVert*)	( pRawData + pSubMesh->mpBoneVertLUT);


			int				nVerts		= (int)	pSubMesh->mnVertices;
			int				nTris		= (int)	pSubMesh->mnTriangles;
			int				szBoneVert	= (int)	pSubMesh->mszBoneVertLUT;


			//
			// Get Skin
			//
			int				skin;
			for( skin=0; skin<nSkins ; ++skin )
				if( pSubMesh->mSkinID == gpModels[inIndex].mpSkinIDs[skin] )
					break;

			pGeo->mSkinIndex		= skin;

			//
			// Copy info to Geometry Model
			// 
			pGeo->mnTriangles		= nTris;
			pGeo->mnVertices		= nVerts;
			pGeo->mpTriangles		= pTris;
			pGeo->mpVertices		= new LH3D_MemVertex[nVerts];
			pGeo->mpXformedVertices	= new LH3D_MemVertex[nVerts];


			//
			// Compare to Base Model for Morphing
			//
			if( inIndex )
			{	
				if( gpModels[0].mpMeshes[mesh].mpSubModels[submesh].mnTriangles != nTris )
				{
					printf( "Invalid Number of Triangles in Morphtarget\n" );
					Shutdown( inIndex );
					return;	
				}

				if( gpModels[0].mpMeshes[mesh].mpSubModels[submesh].mnVertices != nVerts )
				{
					printf( "Invalid Number of Vertices in Morphtarget\n" );
					Shutdown( inIndex );
					return;	
				}
			}



			//
			// Write Bone Indices
			//
			int		BoneVert;
			int		vertind = 0;
			for( BoneVert=0 ; BoneVert<szBoneVert ; ++BoneVert )
			{
				int vert;
				for( vert=0 ; vert<pBoneVert[BoneVert].mnVertices ; ++vert )
				{
					LH3D_MemVertex	*pVertex	= &pGeo->mpVertices[vertind];
		
					pVertex->mnBone = pBoneVert[BoneVert].mBoneIndex;
					++vertind;
				}
			}



			//
			// Copy Vertex Info
			//
			for( vertind=0 ; vertind<nVerts ; ++vertind )
			{
				LH3D_MemVertex	*pDst	= &pGeo->mpVertices[vertind];
				LH3D_MemVertex	*pDst2	= &pGeo->mpXformedVertices[vertind];
				LH3D_Vertex		*pSrc	= &pVertices[vertind];

				pDst2->mNormal		= pDst->mNormal		= pSrc->mNormal;
				pDst2->mPosition	= pDst->mPosition	= pSrc->mPosition;
				pDst2->mTexCoords	= pDst->mTexCoords	= pSrc->mTexCoords;
			}
		}
	}

	//
	// Enable Controls
	//

	if( inIndex == 1 )
		gCAlign->enable( );

	if( inIndex == 2 )
		gCStrength->enable( );

	if( inIndex == 3 )
		gCFat->enable( );
}




/*****************************************************************************
 Helper function for revised XFormVertices function
 Vertex Delta Morphing Method

 Note:	Implement Operator- for class Vec3 in math.h
		inline Vec3	operator- ( const Vec3& v3 ) const		
		{ return Vec3( v[0] - v3.v[0] , v[1] - v3.v[1] , v[2] - v3.v[2] ); }

 mlinehan 4/15/2001
*****************************************************************************/
void MorphVertex(	Vec3 *Base,		//pointer to vector in the base model
		  			Vec3 *Good,		//pointer to vector in the good model
					Vec3 *Strong,	//pointer to vector in the strong model
					Vec3 *Fat,		//pointer to vector in the fat model
					float PGood,	//percentage good
					float PStrong,	//percentage strong
					float PFat,		//percentage fat
					Vec3 *Result)	//resulting vector
{
	//Some temporary storage for our calculations
	Vec3 DeltaGood, DeltaStrong, DeltaFat;

	//Calculate how this vertex moves as the titian becomes good, strong, fat
	if (PGood)   DeltaGood   = (*Good   - *Base) * PGood;
	if (PStrong) DeltaStrong = (*Strong - *Base) * PStrong;
	if (PFat)    DeltaFat    = (*Fat    - *Base) * PFat;

	//Combine the good, strong, fat movement back into the
	//base model, and return through Result
	*Result = *Base + DeltaGood + DeltaStrong + DeltaFat;
}





/*****************************************************************************
 Helper function for revised XFormVertices function

  Note: Implement Operator- for class Vec2 in math.h
		inline Vec2	operator- ( const Vec2& v2 ) const		
		{ return Vec2( v[0] - v2.v[0], v[1] - v2.v[1] ); }

 mlinehan 4/15/2001
*****************************************************************************/
void MorphCoord(	Vec2 *Base,		//pointer to textcoord in the base model
					Vec2 *Good,		//pointer to textcoord in the good model
					Vec2 *Strong,	//pointer to textcoord in the strong model
					Vec2 *Fat,		//pointer to textcoord in the fat model
					float PGood,	//percentage good
					float PStrong,	//percentage strong
					float PFat,		//percentage fat
					Vec2 *Result)	//resulting textcoord
{
	//Some temporary storage for our calculations
	Vec2 DeltaGood, DeltaStrong, DeltaFat;

	//Calculate how this vertex moves as the titian becomes good, strong, fat
	if (PGood)   DeltaGood   = (*Good   - *Base) * PGood;
	if (PStrong) DeltaStrong = (*Strong - *Base) * PStrong;
	if (PFat)	DeltaFat    = (*Fat    - *Base) * PFat;

	//Combine the good, strong, fat movement back into the
	//base model, and return through Result
	*Result = *Base + DeltaGood + DeltaStrong + DeltaFat;
}





/*****************************************************************************
 Updated to use Vertex Delta Morphing Method
 mlinehan 4/15/2001
*****************************************************************************/
void XFormVertices( )
{

	//
	// Prepare Target Model
	//
	if( gBaseChanged )
	{
		Shutdown( 4 );

		gpModels[4].mnMeshes = gpModels[0].mnMeshes;
		gpModels[4].mpMeshes = new LH3D_SubModel[gpModels[0].mnMeshes];

		int		mesh;
		for( mesh=0 ; mesh<gpModels[0].mnMeshes ; ++mesh )
		{
			gpModels[4].mpMeshes[mesh].mnSubModels		= gpModels[0].mpMeshes[mesh].mnSubModels;
			gpModels[4].mpMeshes[mesh].mpSubModels		= new LH3D_GeoModel[gpModels[4].mpMeshes[mesh].mnSubModels];

			gpModels[4].mpMeshes[mesh].mpXformedBones   = new LH3D_Bone[gpModels[0].mpMeshes[mesh].mnBones];

			int		submesh;
			for( submesh=0 ; submesh<gpModels[4].mpMeshes[mesh].mnSubModels ; ++submesh )
			{
				gpModels[4].mpMeshes[mesh].mpSubModels[submesh].mnTriangles = gpModels[0].mpMeshes[mesh].mpSubModels[submesh].mnTriangles;
				gpModels[4].mpMeshes[mesh].mpSubModels[submesh].mpTriangles = gpModels[0].mpMeshes[mesh].mpSubModels[submesh].mpTriangles;
				gpModels[4].mpMeshes[mesh].mpSubModels[submesh].mnVertices  = gpModels[0].mpMeshes[mesh].mpSubModels[submesh].mnVertices;

				gpModels[4].mpMeshes[mesh].mpSubModels[submesh].mpXformedVertices = new LH3D_MemVertex[gpModels[0].mpMeshes[mesh].mpSubModels[submesh].mnVertices];
			}
		}
	}


	//
	// Process Models
	//
	int		model;
	for( model=0 ; model<4 ; ++model )
	{
		if( !gpModels[model].mLoaded ) continue;

		int		mesh;
		for( mesh=0 ; mesh<gpModels[model].mnMeshes ; ++mesh )
		{
			//
			// Evaluate Bones for Models first
			//
			int		Bone;
			for( Bone=0 ; Bone<gpModels[model].mpMeshes[mesh].mnBones ; ++Bone )
			{
				LH3D_Bone	*pSrc = gpModels[model].mpMeshes[mesh].mpBones+Bone;
				LH3D_Bone	*pDst = gpModels[model].mpMeshes[mesh].mpXformedBones+Bone;

				//
				// Use boneinfo from animation if loaded
				//
				if( gpANMBuffer )
				{
					float		blend = gfAnimTime - (float)((int) gfAnimTime);

					ANM_Bone	*pANMSrc1 = gppANMFrames[(int)gfAnimTime]->mpBones+Bone;
					ANM_Bone	*pANMSrc2 = gppANMFrames[(int)gfAnimTime+1]->mpBones+Bone;

					ANM_Bone	ANMSrc2;

					ANMSrc2.mPosition = pANMSrc1->mPosition * (1-blend) + pANMSrc2->mPosition * (blend);
					
					ANMSrc2.mXAxis = pANMSrc1->mXAxis * (1-blend) + pANMSrc2->mXAxis * (blend);
					ANMSrc2.mYAxis = pANMSrc1->mYAxis * (1-blend) + pANMSrc2->mYAxis * (blend);
					ANMSrc2.mZAxis = pANMSrc1->mZAxis * (1-blend) + pANMSrc2->mZAxis * (blend);


					if( pSrc->mParent != -1 )
					{
						LH3D_Bone	*pParent = gpModels[model].mpMeshes[mesh].mpXformedBones+pSrc->mParent;

						Mat4		r(	pParent->mXAxis[0],pParent->mYAxis[0],pParent->mZAxis[0],0,
										pParent->mXAxis[1],pParent->mYAxis[1],pParent->mZAxis[1],0,
										pParent->mXAxis[2],pParent->mYAxis[2],pParent->mZAxis[2],0,
										0						,	0					,	0					,1);

						pDst->mPosition  = r * ANMSrc2.mPosition + pParent->mPosition;

						pDst->mXAxis	 = r * ANMSrc2.mXAxis;
						pDst->mYAxis	 = r * ANMSrc2.mYAxis;
						pDst->mZAxis	 = r * ANMSrc2.mZAxis;
					}
					else
					{
						pDst->mPosition  = ANMSrc2.mPosition;

						pDst->mXAxis	 = ANMSrc2.mXAxis;
						pDst->mYAxis	 = ANMSrc2.mYAxis;
						pDst->mZAxis	 = ANMSrc2.mZAxis;		
					}
				}
				else
				{
					if( pSrc->mParent != -1 )
					{
						LH3D_Bone	*pParent = gpModels[model].mpMeshes[mesh].mpXformedBones+pSrc->mParent;

						Mat4		r(	pParent->mXAxis[0],pParent->mYAxis[0],pParent->mZAxis[0],0,
										pParent->mXAxis[1],pParent->mYAxis[1],pParent->mZAxis[1],0,
										pParent->mXAxis[2],pParent->mYAxis[2],pParent->mZAxis[2],0,
										0				,	0				,	0				,1);

						pDst->mPosition  = r * pSrc->mPosition + pParent->mPosition;

						pDst->mXAxis	 = r * pSrc->mXAxis;
						pDst->mYAxis	 = r * pSrc->mYAxis;
						pDst->mZAxis	 = r * pSrc->mZAxis;
					}
					else
					{
						pDst->mPosition  = pSrc->mPosition;

						pDst->mXAxis	 = pSrc->mXAxis;
						pDst->mYAxis	 = pSrc->mYAxis;
						pDst->mZAxis	 = pSrc->mZAxis;		
					}
				}
			}


			//
			// Then Transform Vertices for each GeoModel
			//
			int		submesh;
			for( submesh=0 ; submesh<gpModels[model].mpMeshes[mesh].mnSubModels ; ++submesh )
			{
				LH3D_GeoModel*		pGeo = gpModels[model].mpMeshes[mesh].mpSubModels+submesh;

				int		Vertex;
				for( Vertex=0 ; Vertex<pGeo->mnVertices ; ++Vertex )
				{
					LH3D_MemVertex*	pVertex = pGeo->mpVertices+Vertex;
					LH3D_MemVertex*	pDst	= pGeo->mpXformedVertices+Vertex;

					if( Bone )
					{
						LH3D_Bone*		pBone	= gpModels[model].mpMeshes[mesh].mpXformedBones+pVertex->mnBone;

						Mat4		r(	pBone->mXAxis[0],pBone->mYAxis[0],pBone->mZAxis[0], 0,
										pBone->mXAxis[1],pBone->mYAxis[1],pBone->mZAxis[1], 0,
										pBone->mXAxis[2],pBone->mYAxis[2],pBone->mZAxis[2], 0,
										0				,	0			 ,	0			  , 1);
						// Rotate the Normal
						pDst->mNormal	= r * pVertex->mNormal;
						// Rotate Position and Translate
						pDst->mPosition = r * pVertex->mPosition + pBone->mPosition;
					}
					else
					{
						// Rotate the Normal
						pDst->mNormal	= pVertex->mNormal;
						// Rotate Position and Translate
						pDst->mPosition = pVertex->mPosition;
					}
				}
			}
		}
	}


	//Setup our morphing percentages
	//Set it too 0.0f if model is not loaded
	float PGood   = gfAlignment;
	float PStrong = gfStrength;
	float PFat    = gfFatness;
	if( !gpModels[1].mLoaded ) PGood   =0.0f;
	if( !gpModels[2].mLoaded ) PStrong =0.0f;
	if( !gpModels[3].mLoaded ) PFat    =0.0f;

	//iterate model meshes
	int	mesh;
	for( mesh=0 ; mesh<gpModels[0].mnMeshes ; ++mesh )
	{
		//iterate bones in this mesh
		int Bone;
		for( Bone=0 ; Bone<gpModels[0].mpMeshes[mesh].mnBones ; ++Bone )
		{
			//construct pointers to the source bone vertex in each souce model
			LH3D_Bone *pSrc0 = gpModels[0].mLoaded ? gpModels[0].mpMeshes[mesh].mpXformedBones+Bone : NULL;
			LH3D_Bone *pSrc1 = gpModels[1].mLoaded ? gpModels[1].mpMeshes[mesh].mpXformedBones+Bone : NULL;
			LH3D_Bone *pSrc2 = gpModels[2].mLoaded ? gpModels[2].mpMeshes[mesh].mpXformedBones+Bone : NULL;
			LH3D_Bone *pSrc3 = gpModels[3].mLoaded ? gpModels[3].mpMeshes[mesh].mpXformedBones+Bone : NULL;

			//construct pointer to destination bone vertex
			LH3D_Bone	*pDst  = gpModels[4].mpMeshes[mesh].mpXformedBones+Bone;

			//perform the morph for mPositon
			MorphVertex(&pSrc0->mPosition,	//pointer to vector in the base model
						&pSrc1->mPosition,	//pointer to vector in the good model
						&pSrc2->mPosition,	//pointer to vector in the strong model
						&pSrc3->mPosition,	//pointer to vector in the fat model
						PGood,				//percentage good
						PStrong,			//percentage strong
						PFat,				//percentage fat
						&pDst->mPosition);	//resulting vector

			//perform the morph for mXAxis
			MorphVertex(&pSrc0->mXAxis,		//pointer to vector in the base model
						&pSrc1->mXAxis,		//pointer to vector in the good model
						&pSrc2->mXAxis,		//pointer to vector in the strong model
						&pSrc3->mXAxis,		//pointer to vector in the fat model
						PGood,				//percentage good
						PStrong,			//percentage strong
						PFat,				//percentage fat
						&pDst->mXAxis);		//resulting vector

			//perform the morph for mYAxis
			MorphVertex(&pSrc0->mYAxis,		//pointer to vector in the base model
						&pSrc1->mYAxis,		//pointer to vector in the good model
						&pSrc2->mYAxis,		//pointer to vector in the strong model
						&pSrc3->mYAxis,		//pointer to vector in the fat model
						PGood,				//percentage good
						PStrong,			//percentage strong
						PFat,				//percentage fat
						&pDst->mYAxis);		//resulting vector

			//perform the morph for mZAxis
			MorphVertex(&pSrc0->mZAxis,		//pointer to vector in the base model
						&pSrc1->mZAxis,		//pointer to vector in the good model
						&pSrc2->mZAxis,		//pointer to vector in the strong model
						&pSrc3->mZAxis,		//pointer to vector in the fat model
						PGood,				//percentage good
						PStrong,			//percentage strong
						PFat,				//percentage fat
						&pDst->mZAxis);		//resulting vector

		}

		//iterate submesh in mesh
		int	submesh;
		for( submesh=0 ; submesh<gpModels[0].mpMeshes[mesh].mnSubModels ; ++submesh )
		{
			//construct source pointers
			LH3D_GeoModel* pGeo0 = gpModels[0].mLoaded ? gpModels[0].mpMeshes[mesh].mpSubModels+submesh : NULL;
			LH3D_GeoModel* pGeo1 = gpModels[1].mLoaded ? gpModels[1].mpMeshes[mesh].mpSubModels+submesh : NULL;
			LH3D_GeoModel* pGeo2 = gpModels[2].mLoaded ? gpModels[2].mpMeshes[mesh].mpSubModels+submesh : NULL;
			LH3D_GeoModel* pGeo3 = gpModels[3].mLoaded ? gpModels[3].mpMeshes[mesh].mpSubModels+submesh : NULL;
		
			//iterate vertexes in submesh
			int vert;
			for( vert=0 ; vert<gpModels[0].mpMeshes[mesh].mpSubModels[submesh].mnVertices ; ++vert )
			{
				//construct pointers to source vertex in each source model
				LH3D_MemVertex *pSrc0 = gpModels[0].mLoaded ? pGeo0->mpXformedVertices+vert : NULL;
				LH3D_MemVertex *pSrc1 = gpModels[1].mLoaded ? pGeo1->mpXformedVertices+vert : NULL;
				LH3D_MemVertex *pSrc2 = gpModels[2].mLoaded ? pGeo2->mpXformedVertices+vert : NULL;
				LH3D_MemVertex *pSrc3 = gpModels[3].mLoaded ? pGeo3->mpXformedVertices+vert : NULL;

				//construct a ponter to the result vertex
				LH3D_MemVertex *pDst = gpModels[4].mpMeshes[mesh].mpSubModels[submesh].mpXformedVertices+vert;

				//perform the morph for mPositon
				MorphVertex(&pSrc0->mPosition,	//pointer to vector in the base model
							&pSrc1->mPosition,	//pointer to vector in the good model
							&pSrc2->mPosition,	//pointer to vector in the strong model
							&pSrc3->mPosition,	//pointer to vector in the fat model
							PGood,				//percentage good
							PStrong,			//percentage strong
							PFat,				//percentage fat
							&pDst->mPosition);	//resulting vector

				//perform the morph for mNormal
				MorphVertex(&pSrc0->mNormal,	//pointer to vector in the base model
							&pSrc1->mNormal,	//pointer to vector in the good model
							&pSrc2->mNormal,	//pointer to vector in the strong model
							&pSrc3->mNormal,	//pointer to vector in the fat model
							PGood,				//percentage good
							PStrong,			//percentage strong
							PFat,				//percentage fat
							&pDst->mNormal);	//resulting vector

				//perform the morph for mTexCoords
				MorphCoord( &pSrc0->mTexCoords,		//pointer to mTexCoords in the base model
							&pSrc1->mTexCoords,		//pointer to mTexCoords in the good model
							&pSrc2->mTexCoords,		//pointer to mTexCoords in the strong model
							&pSrc3->mTexCoords,		//pointer to mTexCoords in the fat model
							PGood,					//percentage good
							PStrong,				//percentage strong
							PFat,					//percentage fat
							&pDst->mTexCoords);		//resulting mTexCoords
			}
		}

	}
	
	gBaseChanged = 0;
}
