// Copyright(c) 2oo1 by Darkyoda (Mental Vortex) & Crytect
#ifndef _LIONHEAD_H_
#define _LIONHEAD_H_
// 
// Description:
// 
// Lionhead LiOnHeAd File Description
// 
// 
// 
// 




// Includes
// no includes yet

//
// Macros
//

#define		LIONHEAD_FILE_HEADER		"LiOnHeAd"



//
// Structures
//

//
// Block Header.
// After each Block Header comes a Block of mnBlockSize bytes, of type mnBlockName.
// After the Block Comes the Next Block Header.
// except its excatly EOF
//
//
struct LH_BlockHeader
{
	char		mnBlockName[32];

	DWORD		mnBlockSize;
};




//
// Special Header for  THM files
//
struct LH_BlockHeader_THM
{
	char		mnBlockName[16];

	DWORD		mUnk1;
	DWORD		mUnk2;
	DWORD		mUnk3;
	DWORD		mUnk4;
};





/*
//
// BockTypes
//
// (local) pointers are pointers from beginning of the block to data
//
==================================
  Found       :
  AllMeshes.g3d

  mnBlockName :
  MESHES

  Description :
  It's a list of Meshes

  Structure   :
  LH_Meshes

	DWORD				mnID				// always MKJC... JC = Jean-Claude Cottier
	DWORD				mnMeshes			// Number of Meshes = MAX_COUNT_3D_MESHES from "AllMeshes.h"

	DWORD				mpMeshes[mnMeshes]	// an Array of Pointers (local) to mMeshes

	L3DFiles			mMeshes[mnMeshes]	// Meshes

==================================
==================================
  Found       :
  AllMeshes.g3d

  mnBlockName :
  LOW%i

  Description :
  It's a Compressed Texture

  Structure   :
  LH_LowResTextureHeader

	DWORD				mUnk1				// This might be number of textures,
	DWORD				mUnk2				// offset and so on
	DWORD				mUnk3

  LH_CompressedTexture
	DWORD				mSize				// Size of this mData + LH_LowResTexture
	DDSURFACEDESC2		mSurfDesc			// Meshes

	BYTE				mData				// Compressed Texture Data

==================================
==================================
  Found       :
  AllMeshes.g3d

  mnBlockName :
  INFO

  Description :
  Compressed Texture Info Block

  Structure   :
  G3D_Info
  	DWORD				mnTexs				// Number of Textures

  Array of mnTexs
  G3D_TexInfo
	DWORD				mID					// Texture ID
	DWORD				mType				// Texture Type

  $$$ Some Other Data !!!!!

==================================
==================================
  Found       :
  AllMeshes.g3d

  mnBlockName :
  %x

  Description :
  A Compressed Texture with numerical ID

  Structure   :
  LH_CompressedTextureHeader

	DWORD				mSize				// Size of this 
	DWORD				mID					// gottabe same as %x in Header Name
	DWORD				mType				// 1 means DXT1 Texture (size different, too)
											// 2 means DXT3 Texture (size different, too)
  LH_CompressedTexture
	DWORD				mTexSize			// Size of this mData + LH_CompressedTexture
	DDSURFACEDESC2		mSurfDesc			// Meshes

    BYTE				mData				// Compressed Texture Data

==================================


==================================
  Found       :
  AllAnims.anm

  mnBlockName :
  Julien%i

  Description :
  Animation with id %i (Lookup in AllMeshes.h)

  Structure   :
  All Data of an Animation file .anm after the Header.


==================================
==================================
  Found       :
  AllAnims.anm

  mnBlockName :
  Body

  Description :
  

  Structure   :
  LH_BodyHeader

  	DWORD				mnID				// always MKJC... JC = Jean-Claude Cottier 
	DWORD				mnAnims				// Number of Animations = MAX_COUNT_3D_ANIMS from "AllMeshes.h"

	DWORD				mpAnims[mnAnims]	// an Array of Pointers (local) to the Headers for the Animations (mAnims)

	ANM_BaseHeader		mAnims[mnAnims]		// Animation Headers

==================================

==================================
  Found       :
  land1begin.exc

  mnBlockName :
  cameraexc

  Description :
  

  Structure   :


==================================

==================================
  Found       :
  markevil.hd

  mnBlockName :
  helpdude

  Description :
  Archive of Animations and Meshes for the little HelperDudes
  
  Structure   :
  LH_HelpDudeHeader
	DWORD					mUnk_1						// number of Animations
	DWORD					mnNames						// +1 cuz mMeshName is not counted
	DWORD					mUnk_2

	char					mModelName[128];
	char					mAnimationName[mnNames][128]

	DWORD					mnModels					// always 1
	DWORD					mSizeModel(s)				
	L3DFile					mModel


	DWORD					mnAnimations;
	DWORD					mUnk_3;
	DWORD					mUnk_4;
	DWORD					mUnk_5;
	DWORD					mUnk_6;
	DWORD					mUnk_7;
	DWORD					mUnk_8;
	DWORD					mUnk_9;
	DWORD					mUnk_10;

	DWORD					mUnk_11;
	DWORD					mnBones1;
	DWORD					mnBones2;
	DWORD					mnBones3;
==================================

==================================
  Found       :
  bzebra.cbn

  mnBlockName :
  Creature

  Description :
  Creature Animations and properties.
  
  Structure   :
  DWORD						mUnk_1
  DWORD						mnAnimations		// ? might be. names lookup in ctrspec%i.txt
  DWORD						mUnk_2

  char						mBaseMeshName[32]	
  char						mEvilMeshName[32]	
  char						mGoodMeshName[32]	
  char						mThinMeshName[32]	
  char						mFatMeshName[32]	
  char						mWeakMeshName[32]	
  char						mStrongMeshName[32]	

<LIST OF POINTERS to Structure>:
LH_SomeStruct1
  DWORD						mUnk_1
  DWORD						mUnk_2
  DWORD						mUnk_3 // 0
  DWORD						mUnk_4 // 0
  DWORD						mUnk_5 // 0
  DWORD						mUnk_6 // 0
  DWORD						mUnk_7 // 0
  DWORD						mUnk_8

  DWORD						mnBones1;
  DWORD						mnBones2;
  DWORD						mnBones3;

  DWORD						mBoneMapping1[mnBones1];
  DWORD						mBoneMapping2[mnBones2];
  LH_SomeStruct2			mBoneMapping[mnBones3]; // size:264

==================================







  Cryect On
==================================
	Found			:
	Guidance.sad


	mnBlockName		;
	LHFileSegmentBankInfo

	Description		:
	This is the Header Information for SAD Files

	Structure:
	LH_FileSegmentBankInfo
		
		DWORD			Size						// Size of this Block after this DWORD
		DWORD			Unknown						// Maybe Nothing
		DWORD			Unknown						// Maybe Nothing
		DWORD			Distinct					// Whether the file contains a single file(bunch of MPEGs to be played together) or not(1 = Long Wav File(MissionariesVerse1.sad) 0 = Is not) Thanks to Rufus here
		BYTE			SADFileDescription[Size-12]	// The File Description
	  
==================================

==================================
	Found			:
	Guidance.sad

  	mnBlockName		;
	LHAudioWaveData

	Description		:
	All of the File data bundled together as one

	Structure		:
	LH_AudioWaveData

		DWORD			Size						// Size of This Block
		BYTE			FileData[Size]			// All the File Data Lumped together

==================================

==================================
	Found			:
	Guidance.sad

	mnBlockName		:
	LHAudioBankSampleTable

	Description		:
	Contains all the file data

	Structures Needed :
	LH_AudioFile
		BYTE			FileName[256]				// FileName
		DWORD			Unknown						// Maybe the FileName is really 260 but something tells me they wouldn't do that
		DWORD			FileIDNumber				// Ordered Number of Position in relation to File Info
		DWORD			DataIDNumber				// Which File is it in relation to where the data is located(normally same as FileIDNumber except in cases of duplicates(desert.sad) allows for file info to be added without regard to file position but unknown if B&W allows for this my current SAD Extractor doesn't take this into account either but then why do you need it?)
		DWORD			FileLength					// Length of the FileData (Rufus is incorrect you don't need to add 8 for otherwise my extractor wouldn't work since I don't do this so he must have made a mistake?)
		DWORD			FileStartPos				// Position which it lays within the filedata
		DWORD			Unknown						// Maybe Nothing
		DWORD			Unknown						// Maybe Nothing
		DWORD			Unknown						// Maybe Nothing
		DWORD			Unknown						// Maybe Nothing
		WORD			CompressionFormat			// 1 = PCM, 80 = MPEG, 85 = MP3(Unknown if B&W supports them)  (Thanks to Rufus for figuring this out)
		WORD			Channels					// 1 = Mono, 2 = Stereo (Thanks to Rufus for figuring this out)
		DWORD			SampleRate					// Sample rate of the file (Thanks to Rufus for figuring this out)
		DWORD			TransferRate				// Rufus says WAV stuff I have no better idea here (Thanks to Rufus for figuring this out)
		WORD			BlockAlign					// Rufus says WAV stuff I have no better idea here (Thanks to Rufus for figuring this out)
		WORD			BitsPerSample				// How many bits per Sample taken should be either 16 or 8 (Thanks to Rufus for figuring this out)
		DWORD			Unknown						// Unknown
		DWORD			Delimiter					// is 0xffff
		DWORD			Delimiter					// is 0xffff
		BYTE			FileDescription[256]		// Description of the File
		BYTE			Unknown[64]					// No one knows this yet from what I've seen(except Lionhead =)

	Structure		:
	LH_AudioBankSampleTable
		DWORD			Size						// Size of this block
		WORD			AudioFiles					// Number of Audio Files
		WORD			Unknown						// Often the same as AudioFiles?
		LH_AudioFile	FileInfo[AudioFiles]		// All the File Information
==================================

==================================
THM Files
THM Files follow a different structure than the normal Lionhead id files and for some strange reason only have 16 bytes for the BlockID

  Found				:
  mpm_2p_1.thm

  mnBlockName		:
   server_map_file									// Yes the block id does start with ' ' otherwise also known as hex 0x20


  Description		:
  Contains a description of a multiplayer map plus a thumbnail of the map with locations of the cities.(You would think THM would stand for Theme wouldn't you?)

  Structures Needed	:
  LH_CityPos
	DWORD				XCoord						// X Coordinate of the City in Pixels
	DWORD				YCoord						// Y Coordinate of the City in Pixels
	BYTE				Color						// Color of the city
													// 0 - Red
													// 1 - Green
													// 2 - Purple
													// 3 - Cyan
													// 4 - Yellow
													// 5 - Blue
													// 6 - Orange
													// 7 - Black
  Structure			:
  LH_OnlineMapDescriptor
	DWORD				MedCities					// How many medium cities
	DWORD				LargeCities					// How many large cities
	DWORD				SmallCities					// How many small cities
	DWORD				MapDescriptionLength		// Length of the Map Description
	BYTE				MapDescription[MapDescriptionLength]	// Description of the map displayed
	LH_CityPos			LargeCitiesPos[LargeCities]	// Positions of the large cities
	LH_CityPos			MedCitiesPos[MedCities]		// Positions of the medium cities
	LH_CityPos			SmallCitiesPos[SmallCities]	// Positions of the small cities
	DWORD				ThumbnailSize				// Size of the the thumbnail
	BYTE				ThumbnailData[ThumbnailSize]// The Thumbnail image in RAW image format (Image size varies but is always the same width and height)

==================================


  */


#endif //_LIONHEAD_H_