// Copyright(c) 2oo1 by Darkyoda and MENTAL VORTEX

// 
// Description:
// 
// Black and White L3D File Loader
// 
//
// 
// 


//
// Comments :
//
// 10.April
// DY : Created this File
//
//
//




// Includes
#include			"main.h"


//
// Globals
//

//
// Filename
//
char					gpFilename[512];


//
// Model Specific
//

LH3D_Model				gpModels[5];	// the fifth model is the result from xform vertices
int						gBaseChanged			= 1;


//
// Animation Specific
// 
GLUI_Button				*gpLoadANM;
char					*gpANMBuffer			= NULL;
ANM_Frame				**gppANMFrames			= NULL;
GLUI_Spinner			*gpAnimTime				= NULL;
GLUI_Checkbox			*gpAnimPlay				= NULL;
float					gfAnimTime				= 0.0;
int						gPlay					= 0;

//
// Texturing Stuff
// for texture extraction
//
GLUI_Button				*gpSavetex;
GLUI_Button				*gpLoadtex[11];
GLUI_Button				*gpSaveModel;

//
// Morphing vars
//
float					gfAlignment				= 0.0;
float					gfFatness				= 0.0;
float					gfStrength				= 0.0;



//
// Viewport/GL Stuff
//
int						*pVisibleMeshList		= NULL;
GLUI_Checkbox			**pMeshBoxes			= NULL;

int						g_bWireFrame			= 0;
int						g_bShowBones			= 0;
int						gG3DModelIndex			= 0;
int						gAnimationIndex			= 0;

Vec3					g_Translation;
Mat4					g_Rotation;

GLfloat					light0_ambient[]		=  { 0.1f, 0.1f, 0.3f, 1.0f};
GLfloat					light0_diffuse[]		=  {  .6f,  .6f, 1.0f, 1.0f};
GLfloat					light0_position[]		= {  .5f,  .5f, 1.0f, 0.0f};

GLfloat					light1_ambient[]		=  { 0.1f, 0.1f, 0.3f, 1.0f};
GLfloat					light1_diffuse[]		=  {  .9f,  .6f, 0.0f, 1.0f};
GLfloat					light1_position[]		= {-1.0f,-1.0f, 1.0f, 0.0f};



//
// GLUT + GLUI Variables
//
int						glutMainWindow;
GLUI					*glui_right,*glui_bottom;
GLUI_Panel				*gpMeshPanel;
GLUI_Spinner			*gCAlign;
GLUI_Spinner			*gCStrength;
GLUI_Spinner			*gCFat;
GLUI_Listbox			*gpLoadFromG3D;
GLUI_Spinner			*gpLoadFromG3D2;
GLUI_Listbox			*gpLoadFromANM;
GLUI_Spinner			*gpLoadFromANM2;


  	
//
// Gl Extensions
//

/* ARB_multitexture command function pointers */
PFNGLMULTITEXCOORD2IARBPROC         glMultiTexCoord2iARB;
PFNGLMULTITEXCOORD3FARBPROC         glMultiTexCoord3fARB;
PFNGLMULTITEXCOORD3FVARBPROC        glMultiTexCoord3fvARB;
PFNGLMULTITEXCOORD2FARBPROC         glMultiTexCoord2fARB;
PFNGLACTIVETEXTUREARBPROC           glActiveTextureARB;

/* ARB_texture_compression */
PFNGLCOMPRESSEDTEXIMAGE3DARBPROC    glCompressedTexImage3DARB;
PFNGLCOMPRESSEDTEXIMAGE2DARBPROC    glCompressedTexImage2DARB;
PFNGLCOMPRESSEDTEXIMAGE1DARBPROC    glCompressedTexImage1DARB;
PFNGLCOMPRESSEDTEXSUBIMAGE3DARBPROC glCompressedTexSubImage3DARB;
PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC glCompressedTexSubImage2DARB;
PFNGLCOMPRESSEDTEXSUBIMAGE1DARBPROC glCompressedTexSubImage1DARB;
PFNGLGETCOMPRESSEDTEXIMAGEARBPROC   glGetCompressedTexImageARB;






//
// Functions
//



//
// GLUI Control Callback
//
void control_cb( int control )
{
	switch( control )
	{
	case CID_LOAD_MODEL:
	case CID_LOAD_MODEL+1:
	case CID_LOAD_MODEL+2:
	case CID_LOAD_MODEL+3:
		LoadModel( control-CID_LOAD_MODEL );
		return;

	case CID_SAVEMODEL:
		SaveModel( 0 );
		return;

	case CID_SAVETEXTURE:
		SaveTexture( 0 );
		return;

	case CID_LOADTEXTURE:
	case CID_LOADTEXTURE+1:
	case CID_LOADTEXTURE+2:
	case CID_LOADTEXTURE+3:
	case CID_LOADTEXTURE+4:
	case CID_LOADTEXTURE+5:
	case CID_LOADTEXTURE+6:
	case CID_LOADTEXTURE+7:
	case CID_LOADTEXTURE+8:
	case CID_LOADTEXTURE+9:
	case CID_LOADTEXTURE+10:
		LoadTexture( 0, control-CID_LOADTEXTURE );
		return;

	case CID_LOADANM:
		LoadANM( );
		return;

	case CID_LOAD_G3D:
		LoadG3D( );
		return;

	case CID_FROMG3D:
		if( gG3DModelIndex > 0 )
		{
			L3DFromG3D( gG3DModelIndex, 0 );

			gpLoadFromG3D2->set_int_val( gG3DModelIndex );
		}
		break;

	case CID_FROMG3D2:
		if( gG3DModelIndex > 0)
		{
			L3DFromG3D( gG3DModelIndex, 0 );
			gpLoadFromG3D->set_int_val( gG3DModelIndex );
		}
		break;

	case CID_FROMANM:
		ANMfromLH( gAnimationIndex );
		gpLoadFromANM2->set_int_val( gAnimationIndex );
		break;

	case CID_FROMANM2:
		ANMfromLH( gAnimationIndex );
		gpLoadFromANM->set_int_val( gAnimationIndex );
		break;

	case CID_LOAD_HD:
		ExtractHD( );
		break;

	default:
		break;
	}
}



//
// OpenGL Rendering Output
//
// How Important is Speed ? it's just one Model with about 1000 polys, 
// with morphing and stuff it sums up to about 2000-3000 polys !
//
//
void glutDisplay( )
{
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	//
	// Setup Camera
	//
	glLoadIdentity();

	glTranslatef( 0 , 0 , -100.f );
	glTranslatef( g_Translation[0] , g_Translation[1], g_Translation[2] );
	glMultMatrixf( g_Rotation.raw( ) );



	//
	// Set States
	//
	glEnable( GL_LIGHTING );
	glEnable( GL_DEPTH_TEST );

	glDepthFunc( GL_LEQUAL );



	XFormVertices( );




	//
	// Render the Object as Solid
	//
	glEnable( GL_TEXTURE_2D );
	glEnable( GL_BLEND );

	int		mesh;
	int		pass; // First pass, render just solid, second render the blended
	for( pass=0 ; pass<2 ; ++pass) 
	for( mesh=0 ; mesh<gpModels->mnMeshes ; ++mesh )
	{
		if( gpModels[0].mpMeshes[mesh].mFlags & LH3D_SubModel::FLAGS_NODRAW )
			continue;

		if( gpModels[0].mpMeshes[mesh].mFlags & LH3D_SubModel::FLAGS_BLEND )
		{
			if( !pass )
				continue;
			glDepthMask( false );
		}
		else
		{
			if( pass )
				continue;
			glDepthMask( true );
		}


		glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );

		int		submesh;
		for( submesh=0 ;submesh<gpModels[4].mpMeshes[mesh].mnSubModels ; ++submesh )
		{
			LH3D_GeoModel*		pGeo = gpModels[4].mpMeshes[mesh].mpSubModels+submesh;


					
			//
			// Setup 
			//
			glVertexPointer  ( 3/*COORDINATES*/, GL_FLOAT/*TYPE*/, sizeof(LH3D_MemVertex)/*BYTE STRIDE*/, (void *)pGeo->mpXformedVertices->mPosition.raw() ); 
			glNormalPointer  (					 GL_FLOAT/*TYPE*/, sizeof(LH3D_MemVertex)/*BYTE STRIDE*/, (void *)pGeo->mpXformedVertices->mNormal.raw() );  
			glTexCoordPointer( 2/*COORDINATES*/, GL_FLOAT/*TYPE*/, sizeof(LH3D_MemVertex)/*BYTE STRIDE*/, (void *)pGeo->mpXformedVertices->mTexCoords.raw() ); 

			glEnableClientState( GL_VERTEX_ARRAY );
			glEnableClientState( GL_NORMAL_ARRAY );
			glEnableClientState( GL_TEXTURE_COORD_ARRAY );



			//
			// And Draw Base
			//
			if( gpModels->mLoaded == 2 )
				glBindTexture( GL_TEXTURE_2D, gpG3DBinds[gpModels[0].mpMeshes[mesh].mpSubModels[submesh].mSkinIndex] );
			else
				glBindTexture( GL_TEXTURE_2D, gpModels[0].mpSkinBinds[gpModels[0].mpMeshes[mesh].mpSubModels[submesh].mSkinIndex] );



			// Filtering
			// The Noise is Mipmapped
			glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
			glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );

			// Enable Texture Combiners
			glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE	, GL_MODULATE	);

			glColor4f( 1, 1, 1, 1 );

			glDrawElements( GL_TRIANGLES, pGeo->mnTriangles*3, GL_UNSIGNED_SHORT, pGeo->mpTriangles );




			//
			// And Draw Alignment
			//
			if( gpModels[1].mLoaded )
			{
				glBindTexture( GL_TEXTURE_2D, gpModels[1].mpSkinBinds[gpModels[0].mpMeshes[mesh].mpSubModels[submesh].mSkinIndex] );

				glEnable( GL_COLOR_MATERIAL );
				glColorMaterial( GL_FRONT, GL_DIFFUSE );

				glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL );

				glColor4f( 0, 0, 0, gfAlignment );

				glDrawElements( GL_TRIANGLES, pGeo->mnTriangles*3, GL_UNSIGNED_SHORT, pGeo->mpTriangles );

				glEnable( GL_LIGHTING );
				glTexEnvi( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );

				glColor4f( 1, 1, 1, 1 );
				glDisable( GL_COLOR_MATERIAL );
			}

			//
			// Draw WireFrame if Req.
			//
			if( g_bWireFrame )
			{
				glPolygonMode( GL_FRONT, GL_LINE );
				glPolygonMode( GL_BACK, GL_POINT );

				glDisable( GL_DEPTH_TEST );
				glDisable( GL_TEXTURE_2D );
				glDisable( GL_BLEND );

				glDrawElements( GL_TRIANGLES, pGeo->mnTriangles*3, GL_UNSIGNED_SHORT, pGeo->mpTriangles );

				glPolygonMode( GL_FRONT_AND_BACK, GL_FILL );

				glEnable( GL_DEPTH_TEST );
				glEnable( GL_TEXTURE_2D );
				glEnable( GL_BLEND );
			}
		}

		glDepthMask( true );
	}


	//
	// Render Bones
	//
	if( g_bShowBones )
	{
		glDisable( GL_DEPTH_TEST );
		glDisable( GL_LIGHTING );
		glEnable( GL_BLEND );
		glDisable( GL_TEXTURE_2D );

		glBegin( GL_LINES );

		int		mesh;
		for( mesh=0 ; mesh<gpModels->mnMeshes ; ++mesh )
		{
			int		bone;
			for( bone=0 ; bone<gpModels->mpMeshes[mesh].mnBones ; ++bone )
			{
				LH3D_Bone *pBone	= gpModels[4].mpMeshes[mesh].mpXformedBones+bone;

				glBegin( GL_LINES );
				glColor3f( 1, 0, 0 );
				glVertex3fv( pBone->mPosition.raw( ) );
				glVertex3fv((pBone->mPosition + pBone->mXAxis).raw( ) );
				glColor3f( 0, 1, 0 );
				glVertex3fv( pBone->mPosition.raw( ) );
				glVertex3fv((pBone->mPosition + pBone->mYAxis).raw( ) );
				glColor3f( 0, 0, 1 );
				glVertex3fv( pBone->mPosition.raw( ) );
				glVertex3fv((pBone->mPosition + pBone->mZAxis).raw( ) );
				glEnd( );

				if( (gpModels->mpMeshes[mesh].mpBones+bone)->mParent != -1 )
				{
					LH3D_Bone *pParent	= gpModels[4].mpMeshes[mesh].mpXformedBones+(gpModels->mpMeshes[mesh].mpBones+bone)->mParent;

					glLineWidth( 5.f );

					glBegin( GL_LINES );
					glColor4f( 1, 1, 1, 0.5 );
					glVertex3fv( pBone->mPosition.raw( ) );
					glColor4f( 1, 1, 1, 1 );
					glVertex3fv( pParent->mPosition.raw( ) );
					glEnd( );

					glLineWidth( 1.f );
				}
			}
		}

		glEnd( );
	}




	//
	// Finalize
	//
	glFinish( );

	glutSwapBuffers( ); 
}



//
// Keyboard Input Function
//
void glutKeyboard(unsigned char Key, int x, int y)
{
}



//
// Mouse Input Function
//
void 
glutMouse(int button, int button_state, int x, int y )
{
}



//
// Idle Function
//
void glutIdle()
{
	if( glutGetWindow( ) != glutMainWindow ) 
		glutSetWindow( glutMainWindow );

	static DWORD old = timeGetTime( );
			DWORD now = timeGetTime( );

	float delta = ((float)now-(float)old)/1000.f;

	old = now;


	gpAnimTime->set_float_val( gfAnimTime );

	if( gPlay )
	{
		gfAnimTime += delta*20;// 20 fps

		if( gANMType )
		{
			if(	gfAnimTime >= gANMListHeaders[gANMListPlaying]->mnFrames-2 ) 
				gfAnimTime = 0;
		}
		else
		{
			if(	gfAnimTime >= ((ANM_BaseHeader*)gpANMBuffer)->mnFrames-2 ) 
				gfAnimTime = 0;
		}
	}
	

	glutPostRedisplay( );
}



//
// Reshape Function
//
void glutReshape( int x, int y )
{
	int tx, ty, tw, th;
	GLUI_Master.get_viewport_area( &tx, &ty, &tw, &th );
	glViewport( tx, ty, tw, th );

	glutPostRedisplay();
}



//
// Initialize GL States and Vars
//
void glInit()
{
	//
	// Get DXT Extension
	//

	/* Retrieve some ARB_multitexture routines. */
	glMultiTexCoord2iARB =
	(PFNGLMULTITEXCOORD2IARBPROC)
	wglGetProcAddress("glMultiTexCoord2iARB");
	glMultiTexCoord3fARB =
	(PFNGLMULTITEXCOORD3FARBPROC)
	wglGetProcAddress("glMultiTexCoord3fARB");
	glMultiTexCoord3fvARB =
	(PFNGLMULTITEXCOORD3FVARBPROC)
	wglGetProcAddress("glMultiTexCoord3fvARB");
	glMultiTexCoord2fARB = 
	(PFNGLMULTITEXCOORD2FARBPROC)
	wglGetProcAddress("glMultiTexCoord2fARB");
	glActiveTextureARB =
	(PFNGLACTIVETEXTUREARBPROC)
	wglGetProcAddress("glActiveTextureARB");

	/* ARB_texture_compression */
	glCompressedTexImage3DARB    = 
	(PFNGLCOMPRESSEDTEXIMAGE3DARBPROC)    
	wglGetProcAddress("glCompressedTexImage3DARB");
	glCompressedTexImage2DARB    = 
	(PFNGLCOMPRESSEDTEXIMAGE2DARBPROC)    
	wglGetProcAddress("glCompressedTexImage2DARB");
	glCompressedTexImage1DARB    = 
	(PFNGLCOMPRESSEDTEXIMAGE1DARBPROC)
	wglGetProcAddress("glCompressedTexImage1DARB");
	glCompressedTexSubImage3DARB = 
	(PFNGLCOMPRESSEDTEXSUBIMAGE3DARBPROC) 
	wglGetProcAddress("glCompressedTexSubImage3DARB");
	glCompressedTexSubImage2DARB = 
	(PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC) 
	wglGetProcAddress("glCompressedTexSubImage2DARB");
	glCompressedTexSubImage1DARB = 
	(PFNGLCOMPRESSEDTEXSUBIMAGE1DARBPROC) 
	wglGetProcAddress("glCompressedTexSubImage1DARB");
	glGetCompressedTexImageARB   = 
	(PFNGLGETCOMPRESSEDTEXIMAGEARBPROC)   
	wglGetProcAddress("glGetCompressedTexImageARB");



	//
	// Set up States
	//
	glEnable( GL_DEPTH_TEST );
	glClearColor( .0f, .5f, 1.f, 1.f );



	//
	// Set up Matrizes
	//
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	glFrustum( -1*.04, 1*.04, -.04, .04, .1, 2048.0 ); // xaspect,yaspect

	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();

	g_Translation[0] = 0.0f;
	g_Translation[1] = 0.0f;
	g_Translation[2] = 0.0f;


	
	//
	// Set Up Lights
	//
	glEnable( GL_LIGHTING );
	glEnable( GL_NORMALIZE );

	glEnable(GL_LIGHT0);
	glLightfv(GL_LIGHT0, GL_AMBIENT, light0_ambient);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, light0_diffuse);
	glLightfv(GL_LIGHT0, GL_POSITION, light0_position);

	glEnable(GL_LIGHT1);
	glLightfv(GL_LIGHT1, GL_AMBIENT, light1_ambient);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, light1_diffuse);
	glLightfv(GL_LIGHT1, GL_POSITION, light1_position);
}



//
// Main - Windows Entry Point
//
void main( int argc, char *argv[ ] )
{
	//
	// Print some Infos
	//
	memset( gpModels, 0x00, 5*sizeof(LH3D_Model) );


	//
	// Init GLUT
	//
	glutInitDisplayMode( GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH );
	glutInitWindowPosition( 50, 50 );
	glutInitWindowSize( 800, 600 );
	glutMainWindow = glutCreateWindow( "Black&White L3D Visualizer by Mental Vortex" );
	glutDisplayFunc( glutDisplay );


	//
	// Set Some GLUI CallBack Functions
	//
	GLUI_Master.set_glutReshapeFunc( glutReshape );  
	GLUI_Master.set_glutKeyboardFunc( glutKeyboard );
	GLUI_Master.set_glutSpecialFunc( NULL );
	GLUI_Master.set_glutMouseFunc( glutMouse );
	GLUI_Master.set_glutIdleFunc( glutIdle );

	glInit();




	//
	// Init GLUI Windows
	//
	glui_right = GLUI_Master.create_glui_subwindow( glutMainWindow, GLUI_SUBWINDOW_RIGHT );
	glui_right->set_main_gfx_window( glutMainWindow );

	GLUI_Panel* pLoadPanel = glui_right->add_rollout( ".: Model :.", false );

	glui_right->add_button_to_panel( pLoadPanel, "Load G3D"			, CID_LOAD_G3D,						control_cb );
	glui_right->add_button_to_panel( pLoadPanel, "Extract HD"		, CID_LOAD_HD,						control_cb );
	glui_right->add_button_to_panel( pLoadPanel, "Load Base Model"	, CID_LOAD_MODEL+BASEMODEL,			control_cb );
	glui_right->add_button_to_panel( pLoadPanel, "Load Evil/Good"	, CID_LOAD_MODEL+EVIL_GOOD_MODEL,	control_cb );
	glui_right->add_button_to_panel( pLoadPanel, "Load Weak/Strong"	, CID_LOAD_MODEL+STRONG_WEAK_MODEL, control_cb );
	glui_right->add_button_to_panel( pLoadPanel, "Load Fat/Thin"		, CID_LOAD_MODEL+FAD_THIN_MODEL,control_cb );

	gpSaveModel  = glui_right->add_button_to_panel( pLoadPanel, "Save Model"	    , CID_SAVEMODEL,	control_cb );
	gpSaveModel->disable( );

	glui_right->add_separator( );

	glui_right->add_checkbox( "Wireframe", &g_bWireFrame );
	glui_right->add_checkbox( "Show Bones", &g_bShowBones );

	glui_right->add_separator( );


	gCAlign = glui_right->add_spinner( "Alignment", GLUI_SPINNER_FLOAT, &gfAlignment, CID_ALIGNMENT, control_cb );
	gCAlign->set_float_limits( 0.f, 1.f );
	gCAlign->disable( );

	gCStrength = glui_right->add_spinner( "Strength", GLUI_SPINNER_FLOAT, &gfStrength, CID_STRENGTH, control_cb );
	gCStrength->set_float_limits( 0.f, 1.f );
	gCStrength->disable( );

	gCFat = glui_right->add_spinner( "Fatness", GLUI_SPINNER_FLOAT, &gfFatness, CID_FADNESS, control_cb );
	gCFat->set_float_limits( 0.f, 1.f );
	gCFat->disable( );

	glui_right->add_separator( );



	GLUI_Panel* pTexturePanel = glui_right->add_rollout( ".: Skins :.", false );

	gpSavetex    = glui_right->add_button_to_panel( pTexturePanel, "Save Texture"	, CID_SAVETEXTURE,	 control_cb );
	gpSavetex->disable( );

	gpLoadtex[0] = glui_right->add_button_to_panel( pTexturePanel, "Load Texture0"	, CID_LOADTEXTURE+0, control_cb );
	gpLoadtex[0]->disable( );

	gpLoadtex[1] = glui_right->add_button_to_panel( pTexturePanel, "Load Texture1"	, CID_LOADTEXTURE+1, control_cb );
	gpLoadtex[1]->disable( );

	gpLoadtex[2] = glui_right->add_button_to_panel( pTexturePanel, "Load Texture2"	, CID_LOADTEXTURE+2, control_cb );
	gpLoadtex[2]->disable( );

	gpLoadtex[3] = glui_right->add_button_to_panel( pTexturePanel, "Load Texture3"	, CID_LOADTEXTURE+3, control_cb );
	gpLoadtex[3]->disable( );

	gpLoadtex[4] = glui_right->add_button_to_panel( pTexturePanel, "Load Texture4"	, CID_LOADTEXTURE+4, control_cb );
	gpLoadtex[4]->disable( );

	gpLoadtex[5] = glui_right->add_button_to_panel( pTexturePanel, "Load Texture5"	, CID_LOADTEXTURE+2, control_cb );
	gpLoadtex[5]->disable( );

	gpLoadtex[6] = glui_right->add_button_to_panel( pTexturePanel, "Load Texture6"	, CID_LOADTEXTURE+3, control_cb );
	gpLoadtex[6]->disable( );

	gpLoadtex[7] = glui_right->add_button_to_panel( pTexturePanel, "Load Texture7"	, CID_LOADTEXTURE+4, control_cb );
	gpLoadtex[7]->disable( );

	gpLoadtex[8] = glui_right->add_button_to_panel( pTexturePanel, "Load Texture8"	, CID_LOADTEXTURE+2, control_cb );
	gpLoadtex[8]->disable( );

	gpLoadtex[9] = glui_right->add_button_to_panel( pTexturePanel, "Load Texture9"	, CID_LOADTEXTURE+3, control_cb );
	gpLoadtex[9]->disable( );

	gpLoadtex[10] = glui_right->add_button_to_panel( pTexturePanel, "Load Texture10"	, CID_LOADTEXTURE+4, control_cb );
	gpLoadtex[10]->disable( );




	GLUI_Panel* pAnimationPanel = glui_right->add_rollout( ".: Animations :.", true );

	gpLoadANM  = glui_right->add_button_to_panel( pAnimationPanel, "Load Animation File"	    , CID_LOADANM,	 control_cb );
	gpLoadANM->disable( );

	gpAnimTime = glui_right->add_spinner_to_panel( pAnimationPanel, "Animate", GLUI_SPINNER_FLOAT, &gfAnimTime );
	gpAnimTime->set_float_limits( 0.f, 1.f );
	gpAnimTime->disable( );

	gpAnimPlay = glui_right->add_checkbox_to_panel( pAnimationPanel, "Play", &gPlay );
	gpAnimPlay->disable( );

#pragma TODO( "Reimplement Mesh Selection" )
	//gpMeshPanel = glui_right->add_rollout( "Meshes" );
	




	
	//
	// Bottom Window
	//
	glui_bottom = GLUI_Master.create_glui_subwindow( glutMainWindow, GLUI_SUBWINDOW_BOTTOM );
	glui_bottom->set_main_gfx_window( glutMainWindow );

	GLUI_Translation	*trans_xy	= glui_bottom->add_translation( "Object XY", GLUI_TRANSLATION_XY, &g_Translation[0] );
	trans_xy->set_speed( .3 );
	glui_bottom->add_column( false );

	GLUI_Translation	*trans_x	= glui_bottom->add_translation( "Object X", GLUI_TRANSLATION_X, &g_Translation[0]  );
	trans_x->set_speed( .1 );
	glui_bottom->add_column( false );

	GLUI_Translation	*trans_y	= glui_bottom->add_translation( "Object Y", GLUI_TRANSLATION_Y, &g_Translation[1] );
	trans_y->set_speed( .1 );
	glui_bottom->add_column( false );

	GLUI_Translation	*trans_z	= glui_bottom->add_translation( "Object Z", GLUI_TRANSLATION_Z, &g_Translation[2] );
	trans_z->set_speed( .6 );
	glui_bottom->add_column( true );
	
	GLUI_Rotation		*view_rot	= glui_bottom->add_rotation( "Object Rot", g_Rotation.raw() );
	view_rot->set_spin( 1.0 );
	glui_bottom->add_column( true );

	gpLoadFromG3D = glui_bottom->add_listbox( "Load From G3D", &gG3DModelIndex, CID_FROMG3D, control_cb );
	gpLoadFromG3D->disable( );

	gpLoadFromG3D2 = glui_bottom->add_spinner( "Load From G3D", GLUI_SPINNER_INT, &gG3DModelIndex, CID_FROMG3D2, control_cb );
	gpLoadFromG3D2->set_speed( 0.05 );
	gpLoadFromG3D2->disable( );

	gpLoadFromANM = glui_bottom->add_listbox( "Load From ANM", &gAnimationIndex, CID_FROMANM, control_cb );
	gpLoadFromANM->disable( );

	gpLoadFromANM2 = glui_bottom->add_spinner( "Load From ANM", GLUI_SPINNER_INT, &gAnimationIndex, CID_FROMANM2, control_cb );
	gpLoadFromANM2->set_speed( 0.05 );
	gpLoadFromANM2->disable( );



	//
	// Parse the File to be processed
	//
	if( argc > 1 )
	{
		//
		// Read File
		// First init GLUT cuz we create display list (subject of change)
		//		
		strcpy( gpFilename, argv[1] );

		ReadL3D( 0 );
	}
	else
	{
		printf( "No File Specified\n" );
		printf( "Usage :\n" );
		printf( "  Black and White L3D Visualizer.exe filename\n" );
	}





	//
	// Run Main Loop
	//
	glutMainLoop();





	//
	// Cleanup
	// 

	int		model;
	for( model=0 ; model<5 ; ++model )
		Shutdown( model );

	ShutANM( );
	ShutG3D( );
}
