// Copyright(c) 2oo1 by Mental Vortex
#ifndef _MAIN_H_
#define _MAIN_H_
// 
// Description:
// 
// Lionhead 3D File Format .l3d
// 
// 
// 
// 




// Includes
#include			<windows.h>
#include			<gl/glut.h>
#include			<gl/glext.h>
#include			<stdio.h>
#include			<conio.h>
#include			<assert.h>

#include			"allmeshes.h"
#include			"lionhead.h"
#include			"l3d.h"
#include			"anm.h"
#include			"g3d.h"
#include			"hd.h"

#include			"glui.h"
#include			"math.h"
#include			"tga.h"



//
// MACROS
//

//
// Use this macro like #pragma TODO( string ) to display a message in the compile wnd
//
#define QUOTE(x) #x     
#define QQUOTE(y) QUOTE(y)     
#define TODO(str) message ( "TODO : " __FILE__ "(" QQUOTE(__LINE__) ") :  " str )
// end of TODO macro

#define CID_LOADTEXTURE		32// - 43
#define	CID_SAVEMODEL		79
#define CID_LOAD_MODEL		80// - 83		// Control ID for the Load Model Buttons
#define	CID_SAVETEXTURE		84
#define CID_LOADANM			85
#define CID_PLAY			86
#define CID_STOP			87
#define CID_LOAD_G3D		88
#define CID_FROMG3D			89
#define CID_FROMG3D2		90
#define CID_FROMANM			91
#define CID_FROMANM2		92
#define CID_FADNESS			93
#define CID_STRENGTH		94
#define CID_ALIGNMENT		95
#define CID_MESH			96				// Control ID for the Submesh Checkboxes
#define	CID_LOAD_HD			97



#define BASEMODEL			0
#define EVIL_GOOD_MODEL		1
#define STRONG_WEAK_MODEL	2
#define FAD_THIN_MODEL		3


#define MODEL_NONE			0
#define MODEL_LOADED		1






//
// Functions
//




//
// Gl Extensions
//

/* ARB_multitexture command function pointers */
extern PFNGLMULTITEXCOORD2IARBPROC         glMultiTexCoord2iARB;
extern PFNGLMULTITEXCOORD3FARBPROC         glMultiTexCoord3fARB;
extern PFNGLMULTITEXCOORD3FVARBPROC        glMultiTexCoord3fvARB;
extern PFNGLMULTITEXCOORD2FARBPROC         glMultiTexCoord2fARB;
extern PFNGLACTIVETEXTUREARBPROC           glActiveTextureARB;

/* ARB_texture_compression */
extern PFNGLCOMPRESSEDTEXIMAGE3DARBPROC    glCompressedTexImage3DARB;
extern PFNGLCOMPRESSEDTEXIMAGE2DARBPROC    glCompressedTexImage2DARB;
extern PFNGLCOMPRESSEDTEXIMAGE1DARBPROC    glCompressedTexImage1DARB;
extern PFNGLCOMPRESSEDTEXSUBIMAGE3DARBPROC glCompressedTexSubImage3DARB;
extern PFNGLCOMPRESSEDTEXSUBIMAGE2DARBPROC glCompressedTexSubImage2DARB;
extern PFNGLCOMPRESSEDTEXSUBIMAGE1DARBPROC glCompressedTexSubImage1DARB;
extern PFNGLGETCOMPRESSEDTEXIMAGEARBPROC   glGetCompressedTexImageARB;




// L3D
extern int		LoadDialog			( char *inTitle, char *inFilter );
extern int		SaveDialog			( char *inTitle, char *inFilter );
extern void		LoadModel			( int inIndex );
extern void		SaveModel			( int inIndex );
extern void		SaveTexture			( int inIndex );
extern void		LoadTexture			( int inModelIndex, int inSkinIndex );
extern void		Shutdown			( int inIndex );
extern void		ReadL3D				( int inIndex );
extern void		L3DfromMem			( void *inSrc, int inIndex);
extern void		XFormVertices		( );

//ANM
extern void		LoadANM				( void );
extern void		ShutANM				( void );
extern void		ANMfromLH			( int inIndex );					// reads an ANM from Lionhead file if loaded

//G3D
extern void		LoadG3D				( void );
extern void		ShutG3D				( void );
extern void		L3DFromG3D			( DWORD inMshIndex, DWORD inModelIndex );

//HD
extern void		ExtractHD			( void );

//
// Variables
//
extern char					gpFilename[512];
extern LH3D_Model			gpModels[5];
extern int					gBaseChanged;
extern int					*pVisibleMeshList;
extern GLUI_Button			*gpSavetex;
extern GLUI_Button			*gpLoadtex[11];
extern GLUI_Button			*gpSaveModel;
extern float				gfAlignment;
extern float				gfFatness;
extern float				gfStrength;
extern GLUI_Spinner			*gCAlign;
extern GLUI_Spinner			*gCStrength;
extern GLUI_Spinner			*gCFat;
extern char					*gpANMBuffer;
extern GLUI_Button			*gpLoadANM;
extern ANM_Frame			**gppANMFrames;
extern GLUI_Spinner			*gpAnimTime;
extern float				gfAnimTime;
extern GLUI_Checkbox		*gpAnimPlay;
extern GLUI_Listbox			*gpLoadFromG3D;
extern GLUI_Spinner			*gpLoadFromG3D2;
extern GLUI_Listbox			*gpLoadFromANM;
extern GLUI_Spinner			*gpLoadFromANM2;
extern unsigned int			*gpG3DBinds;
extern int					gANMType;
extern ANM_BaseHeader		**gANMListHeaders;
extern int					gANMListPlaying;


#endif//_MAIN_H_