// Copyright(c) 2oo1 by Darkyoda and MENTAL VORTEX

// 
// Description:
// 
// Black and White L3D File Loader
// 
//
// 
// 


//
// Comments :
//
// 10.April
// DY : Created this File
//
//
//




// Includes
#include			<windows.h>
#include			<gl/glut.h>
#include			<stdio.h>
#include			<conio.h>
#include			<assert.h>
#include			"tga.h"


char *ExtractFilename( char *inPath )
{
	char *p = inPath +strlen(inPath);

	while( (*p != '\\') && (*p != '/') )
	{
		--p;
		if(p == inPath)
			return p;
	}

	++p;

	return p;
}


//
// Save a RGBA4444 as TGA
//
void TGA_SaveRGBA4444( void *inData, char *inName, int inNBlocks )
{
	assert( inData );
	assert( inName );
	assert( inNBlocks );

	char	filename[256];

	TGA_Header	Header;

	Header.mIDLength				= 0;
	Header.mColorMapType			= 0;
	Header.mImageType				= 2;
	Header.mColorMapFirstEntryIndex	= 0;
	Header.mColorMapEntrySize		= 0;
	Header.mColorMapLength			= 0;
	Header.mImageDescriptor			= 8;
	Header.mPixelDepth				= 32;
	Header.mXOrigin					= 0;
	Header.mXSize					= 256;
	Header.mYOrigin					= 0;
	Header.mYSize					= 256;

	byte		*b					= (byte*) inData;

	int		block;
	for( block=0 ; block<inNBlocks ; ++block )
	{
		FILE		*fp;
		byte		pBuffer[256*256*4];						// RGBA8888
		byte		*p					= pBuffer;

		//
		// Open File
		//
		sprintf( filename, "%i-%s.tga", block, ExtractFilename(inName) );

		fp = fopen( filename, "w+" );


		//
		// Write Data
		//
		b += 4; // Skip SkinID

		//
		// Yeah i know Targa is flipped and so on, but this is a lot easier to code :)
		//

		int		x;
		for( x=0 ; x<256*256 ; ++x )
		{
			byte	b1,b2;

			b1	 = *b++;
			b2	 = *b++;

			*p++ = (   b1       & 15 ) * 17;
			*p++ = ( ( b1 >>4 ) & 15 ) * 17;
			*p++ = (   b2       & 15 ) * 17;
			*p++ = ( ( b2 >>4 ) & 15 ) * 17;
		}

		fwrite( &Header, sizeof(TGA_Header), 1, fp);
		fwrite( pBuffer, 256*256*4, 1, fp );

		fclose( fp );
	}
}



//
// Loads a RGBA8888 TGA and stores it as a RGBA 4444 Image
//
void TGA_LoadRGBA( byte *inData, char *inName )
{
	assert( inData );
	assert( inName );

	byte		data[256*256*4];

	TGA_Header	Header;

	FILE* fp = fopen( inName, "rb" );

	fread( &Header, sizeof(TGA_Header), 1, fp );

	if((Header.mImageType != 2)||(Header.mPixelDepth != 32)||(Header.mImageDescriptor != 8)||(Header.mXSize != 256)||(Header.mYSize != 256))
	{
		printf( "Invalid TGA Format (expecting RGBA 256x256x32)\n" );
		fclose( fp );
		return;
	}

	fread( data, 256*256*4, 1, fp );

	fclose(fp);

	//
	// Write Data
	//
	byte *p = inData; // asume skinid already skipped
	byte *p2 = data;

	int		x;
	for( x=0 ; x<65536 ; ++x )
	{
		byte	r,g,b,a;

		r = *p2++;
		g = *p2++;
		b = *p2++;
		a = *p2++;

		*p++ = ( ((r/17) & 0x0f) + (( (g/17)<<4 ) & ~0x0f) );
		*p++ = ( ((b/17) & 0x0f) + (( (a/17)<<4 ) & ~0x0f) );		
	}
}